/****************************************************************************/
//Screen Functions : appx-client-item.js
//01/28/2014
//Chris Smith
/****************************************************************************/



//find the smallest container for an item
//@see CharView.lookupDisplay
//TODO? adjust box x&y++ and col&row--?
function appxitembox(pos_row,pos_col) {
    var ret = null;
    var dim =  appx_session.screencols * appx_session.screenrows;
    var boxes = appx_session.current_show.boxes;
    for (var boxIdx = 0; boxIdx < boxes.length; boxIdx++) {
        var box = boxes[boxIdx];
        if ( pos_col >= box.begin_column &&
	     pos_col <= box.end_column &&
	     pos_row >= box.begin_row &&
	     pos_row <= box.end_row ) 
	{
	    ret = box;
	}
    }
    
    if( ret != null && ret.newbox >= 0 )
	ret = boxes[ret.newbox];

    return ret;
}

//TODO turn Document.CHR_SCANNABLE into field spec? Display.addField / AppxButton.addScanButton
//Items Message Handler
function appxitemshandler(x) {

    //debugger;
    var modeFound = false;
    var $bar = $("#appx-status-msg");
    //if( $bar ) { $bar.html(""); }

    try {
        appx_session.items.length = 0;//clear array

        //sendappxitems();
        //console.log("item position needs to be cached so sendappxshow works propertly");
        var i = 0;
        //need the wWidgetType for most items - CS
        var wt = null;

        while (x.data.length > 0) {
	    wt = null;
            var item = x.data.shift(), $itemhtml = $("<div>");
	    //console.log("item row=%d, col=%d special=%d wt=%d label=%s",item.pos_row,item.pos_col,item.special,(item.widget == null ? -1 : item.widget.wWidgetType),item.data);

	    appxSetModifiableCapable(item,false);

        //MFld.read #3197
        item.maxLen = item.size_rows * item.size_cols;
        switch (item.type) {
            case 1://ELEM_ALP_CONTIG
            case 2://ELEM_ALP_NON_CONTIG
            case 13://ELEM_ALP_SUBSTR
            case 14://ELEM_ALP_CMPRS
                var loInt = item.digits_right;
                var hiInt = item.digits_left;
                if (loInt < 0) loInt += 256;
                if (hiInt < 0) hiInt += 256;
                item.maxLen = ((hiInt * 256) + loInt);
                break;
            //date field fix
            //TODO: constants or comments
            case 3:
            case 4:
            case 6:
            case 7:
            case 9:
            case 10:
            case 15:
                var i = parseItemLongData(item.rawdata);
                item.data = i.itemdata[0][0];
                break;
            default:
                break;
        }

	    if( item.widget != null ) {
                item.widget = new Widget(0, "", item.widget);
                wt = item.widget.wWidgetType;
	    }

	    if( item.type == 11 && wt == null ) {
		wt = WIDGET_TYPE_CHECK_BOX;
	    }

	    if( appxIsModifiable(item) == false && appxIsModifiableCapable(item) == false && appxIsStatus(item) == false && wt == null ) {
		if (item.type == 11 && wt != WIDGET_TYPE_CHECK_BOX ) {
		    item.data = item.data == "1" ? "Y" : item.data == "0" ? "N" : "";
		}
		var rowtxt = new RowTextStruct();
		rowtxt.type      = ROWTEXT_TYPE_ITEM;
		rowtxt.boxid     = -1;
		rowtxt.pos_row   = item.pos_row;
		rowtxt.pos_col   = item.pos_col;
		rowtxt.size_rows = item.size_rows;
		rowtxt.size_cols = item.size_cols;
		rowtxt.string    = item.data;
		appx_session.rowtext.unshift(rowtxt);
		continue;
	    }

            // item.widget != null
            //TODO: merge item widget stuff with 'normal' widget code
            if (item.widget != null) {
                //item.widget = new Widget(0, "", item.widget); //appxwidgetshandlerparams
                //wt = item.widget.wWidgetType;
                // gotta check this before and after
                //TODO: some fields are still added modifiable in inquire mode
                if (appxIsModifiable(item)) {//item.type == 1 &&
                    item.data = item.data.replace(/\xB6/g, "\r\n").trim(); //all occurrences of ?
                    // found problem in scan popups with wt == null, set to input if null and modifialble
		    if(wt == null && (item.special & 0x02) == 0x02) wt = WIDGET_TYPE_LISTBOX; 
                    if(wt == null) wt = WIDGET_TYPE_RAW_TEXT;
                } else {
                    item.data = item.data.replace(/\xB6/g, "<br/>").trim(); //all occurrences of ?
                    // found problem in scan popups with wt == null, set to label if null and not modifialble
                    if (wt == null) wt = WIDGET_TYPE_LABEL;
                }

                //TODO: order by number or alpha?
                switch (wt) {
                    case WIDGET_TYPE_SLIDER: //31;
                        //                        $itemhtml = $("<div>").html("").height(10).slider({
                        //                            value: parseInt(item.data)
                        //                        });
                        //plugin site: http://simey.me/projects/jquery-ui-slider-pips/
                        //$itemhtml.slider('pips', { rest: 'label', labels: ['0', '1', '2'] });
                        $itemhtml = $("<div>"); //.width(100).height(40); //.slider();
                        //need some padding for the slider
                        var paddedbox = $("<div>").css({ "padding": "10px" });
                        //create the slider
                        //var mslider = $("<div>").slider({ min: 1, max: 5 });
                        var mslider = $("<div>").slider({ min: item.widget.wMinValue, max: item.widget.wMaxValue });
                        //$(mslider).slider('pips', { rest: 'label' });
                        $(mslider).slider('pips',{rest: 'label'}).slider('float');
                        $(paddedbox).append(mslider);
                        $itemhtml.append(paddedbox);
                        break;

                    case WIDGET_TYPE_PROGRESS_BAR: //33;
                        $itemhtml = $("<div>").html("").height(10).progressbar({
                            value: parseInt(item.data)
                        });
                        break;

                    case WIDGET_TYPE_PASSWORD:
                        $itemhtml = $("<input type='password'>").val(item.data);
                        break;

		    case WIDGET_TYPE_LISTBOX: //42;
                        //if ((item.special & 0x04) == 0x04) {
                            $itemhtml = $("<select data='" + item.data + "'>").val(item.data);
			    //} else {
                            //$itemhtml = $("<select>");
			    //}
                        break;

                    case WIDGET_TYPE_LABEL: //2;
                        $itemhtml = $("<span>");
                        $itemhtml.text(item.data);
                        break;

                    case WIDGET_TYPE_PICTURE: 
                        $itemhtml = $("<div>");
                        break;

                    case WIDGET_TYPE_RAW_TEXT: //20
			if( item.size_rows > 1 )
			    $itemhtml = $("<textarea>").css("padding", "0"); //remove extra width
                        else
			    $itemhtml = $("<input type='text'>");
			appxSetModifiableCapable(item,true);
                        if (item.type == 11) {
                            item.data = item.data == "1" ? "Y" : item.data == "0" ? "N" : "";
                        }

                        $itemhtml.val(item.data);
                        //add dirty
                        //$itemhtml.change(function () {
                        //    $(this).addClass("dirty");
                        //});

                        break;

                    //case WIDGET_TYPE_RAW_TEXT: //20
                    //  $itemhtml = $("<input type='text'>");
                    //  break;

                    case WIDGET_TYPE_CHECK_BOX: // 40
                        $itemhtml = $("<input type='checkbox'>");
                        if (item.data == "1") {
                            $itemhtml.prop("checked", true);
                        } else if (item.data == "0") {
                            $itemhtml.prop("checked", false);
                        } else {
                            $itemhtml.prop("indeterminate", true);
                        }

                        $itemhtml.val(item.data);
                        break;

                    case WIDGET_TYPE_FILE_CHOOSER: //51
                        $itemhtml = $("<input>").css({
                            "background": "#fff url(images/folder.png) no-repeat",
                            "overflow": "hidden",
                            "background-position": "99% 50%",
                            "border": "double 1px #555",
                            "padding-right": "5px"
                        });
                        $itemhtml.addClass("appxfilewrapper");
//                        var cp = $("<input type='file' class='appxitem'>").css({
//                            "display": "block",
//                            "width": "100%",
//                            "height": "inherit",
//                            "opacity": "0",
//                            "overflow": "hidden"
//                        }).change(function () { $(this).parent().text($(this).val()); });
//                        //$(cp).addClass("appxfilechooser");
//                        //var ic = $("<img src='images/colorpicker_16.png' />").css({ "position": "absolute", "right": "0px", "top": "2px", "z-index": 100000 });
//                        $itemhtml.append(cp);
//                        //$itemhtml.append(ic);
                        break;

                    case WIDGET_TYPE_COLOR_CHOOSER: //52
                        $itemhtml = $("<div>");
                        $itemhtml.addClass("appxcolorpickerwrapper");
                        var cp = $("<input type='text' class='appxitem'>");
                        $(cp).addClass("appxcolorpicker");
                        var ic = $("<img src='images/colorpicker_16.png' />").css({ "position": "absolute", "right": "0px", "top": "2px", "z-index": 100000 });
                        $itemhtml.append(cp);
                        $itemhtml.append(ic);
                        break;

                    case WIDGET_TYPE_HTML_VIEWER: //60
                        //TODO: check for http:// (iframe)
                        $itemhtml = $("<div>").css("padding", "0"); //remove extra width
                        $itemhtml.html(item.data);
                        $itemhtml.addClass("appx-html-viewer");
                        switch (item.widget.wHtmlViewerType) {
                            case "flash":
                                //can also use <embed></embed> see http://www.w3schools.com/html/html_object.asp
                                //$itemhtml = $("<object data='" + item.data + "'></object>");
                                $itemhtml = $("<object data='" + item.data + "'></object>");
                                break;
                            case "media":
                                //can also use <embed></embed> see http://www.w3schools.com/html/html_object.asp
                                //$itemhtml = $("<object data='" + item.data + "'></object>");
                                $itemhtml = $("<embed src='" + item.data + "'></embed>");
                                break;
                            case "view":
                                //can also use <embed></embed> see http://www.w3schools.com/html/html_object.asp
                                //$itemhtml = $("<object data='" + item.data + "'></object>");
                                $itemhtml = $("<iframe src='" + item.data + "'></iframe>");
                                break;
                            case "browse":
                                //can also use <embed></embed> see http://www.w3schools.com/html/html_object.asp
                                //$itemhtml = $("<object data='" + item.data + "'></object>");
                                $itemhtml = $("<iframe src='" + item.data + "'></iframe>");
                                break;
                            case "edit":
                                //can also use <embed></embed> see http://www.w3schools.com/html/html_object.asp
                                //$itemhtml = $("<object data='" + item.data + "'></object>");
                                $itemhtml = $("<div>" + item.data + "</div>");
                                $itemhtml.addClass("ckeditor");
                                break;
                            case "inline":
                                //can also use <embed></embed> see http://www.w3schools.com/html/html_object.asp
                                //$itemhtml = $("<object data='" + item.data + "'></object>");
                                $itemhtml = $("<div>" + item.data + "</div>");
                                $itemhtml.addClass("ckeditor");
                                break;
                            case "autoedit":
                                //can also use <embed></embed> see http://www.w3schools.com/html/html_object.asp
                                //$itemhtml = $("<object data='" + item.data + "'></object>");
                                $itemhtml = $("<div>" + item.data + "</div>");
                                $itemhtml.addClass("ckeditor");
                                break;
                        }
                        //$itemhtml.addClass("ckeditor");
                        break;

                    case WIDGET_TYPE_HTML_EDITOR: // 63|| item.widget.wWidgetType == WIDGET_TYPE_HTML_EDITOR) {
                        $itemhtml = $("<div>").css({ "padding": "0" }); //remove extra width
                        $itemhtml.html(item.data);
                        $itemhtml.addClass("ckeditor");

                        /*  CONFIG SETTINGS
                        optionMap.put("skin", "'v2'"); // office2003
                        optionMap.put("toolbar", "[" +
                        "  ['Font','FontSize'],['TextColor','BGColor','Bold','Italic','-','Source']," + // '/'
                        "  ['JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock','-'," +
                        "  'NumberedList','BulletedList','-','Outdent','Indent']," +
                        "  ['Cut','Copy','Paste','-','Undo','Redo','-','Link','Table','HorizontalRule']" +
                        "]");
                        */
                        break;
                    case WIDGET_TYPE_FLASH_PLAYER: //64;
                        //can also use <embed></embed> see http://www.w3schools.com/html/html_object.asp
                        $itemhtml = $("<object data='" + item.data + "'></object>");
                        break;
                    case WIDGET_TYPE_TEXT_AREA: //59
                        $itemhtml = $("<textarea>").css("padding", "0"); //remove extra width
                        $itemhtml.val(item.data);
                        break;

                    case WIDGET_TYPE_DATE_CHOOSER: // = 80
                        $itemhtml = $("<div>").addClass("appxdatefield");

                        var i = parseItemLongData(item.rawdata);
			            item.data = i.itemdata[0][0];
                        var maskstr = i.itemdata[1][0].replace(/\_/g, "*"); //.replace(/X/g, "/");

                        for (var z = 0; z < i.itemdata[1][0].length; z++) {
                            if (i.itemdata[1][0][z] == "X") {
                                maskstr = maskstr.replace(maskstr[z], i.itemdata[0][0][z]);
                            }
                        }

			            /**************************************************
			             **
			             **  Build format and data for hidden picker item  
			             **
			             **************************************************/

			            var pickstr = "";
			            var datemsk = "";
			            var timemsk = "";
			            var part = "";

			            for (var z = 0; (z*2) < i.itemdata[2][0].length; z++) {
			                part = i.itemdata[2][0].substring(z*2,(z*2)+2);
			    
			                if (part != "--") {
				            switch( z ) {
				    
				            case 0: // Century
				                pickstr += part;
				                datemsk += "yy";
				                break;
				    
				            case 1: // Year
				                pickstr += part;
				                if (datemsk.length == 0 ) // If there is no century then we ass the mask for year only
					            datemsk += "y";
				                break;
				    
				            case 2: // Month
				                pickstr += part;
				                datemsk += "mm";
				                break;
				    
				            case 3: // Day
				                pickstr += part;
				                datemsk += "dd";
				                break;

				            case 4: // Hour
				                if ( datemsk.length > 0 ) // If there is a date part then we add a space separator to the string
					            pickstr += " ";
				                pickstr += part;
				                timemsk += "HH";
				                break;

				            case 5: // Minute
				                if (timemsk.length > 0 ) { // If there are hours we add the colon separator
					            pickstr += ":";
					            timemsk += ":";
				                }
				                pickstr += part;
				                timemsk += "mm";
				                break;

				            case 6: // Second
				                if (timemsk.length > 0 ) { // If the are minutes we add the colon separator
					            pickstr += ":";
					            timemsk += ":";
				                }
				                pickstr += part;
				                timemsk += "ss";
				                break;

				            case 7: // Thousands
				                if (timemsk.length > 0 ) { // If there are seconds we add the period separator
					            pickstr += ".";
					            timemsk += ".";
				                }
				                pickstr += part + "0"; // Appx does thousands, not milliseconds so we add the third digit
				                timemsk += "l";
				                break;
				            }
			                }
			            }

			            var pickval = '{"value":"' + pickstr + '","datemsk":"' + datemsk + '","timemsk":"' + timemsk + '"}';
			            /**************************************************
			             **
			             **  
			             **
			             **************************************************/

                        var dv = $("<input class='appxdatevalue appxitem' type='text' style='width: 100%; height: 100%'>").val(i.itemdata[0]);
                        var df = $("<input class='appxdatepicker' type='hidden'>").val(pickval);

                        $(dv).mask(maskstr);

                        $itemhtml.append(dv);  //.mask('00/00/00')
                        $itemhtml.append(df);  //.mask('00/00/00')


			            /****************************************************************************************************************************************
                                    $itemhtml = $("<input type='text'>");
                                    $itemhtml.val(item.data);
						            $itemhtml.addClass("appxdatefield");//datefield
                                    //$itemhtml.click(function () {
                                    //    //alert("adding datepicker");
                                    //    $(this).css("z-index", "100000");
                                    //    $(this).datepicker();
                                    //});

                                    //need mask from server
                                    $itemhtml.mask('00/00/0000');
                                    //jquery ui has lots of format options
                                    //$itemhtml.datepicker("option", "dateFormat", "&apos;day&apos; d &apos;of&apos; MM &apos;in the year&apos; yy");
			            ******************************************************************************************************************************************/
                        break;

                    case WIDGET_TYPE_TABLE: //90
                        //alert("table 170");
                        $itemhtml = $("<div>").jqgrid({});
                        //add jqgrid or extention here
                        break;

                    default:
                        if (item.size_rows > 1) {
                            $itemhtml = $("<textarea>").css("padding", "0"); //remove extra width
                            $itemhtml.val(item.data);
                        } else {
                            $itemhtml = $("<div>");
                            $itemhtml.html(item.data);
                        }
                } //end switch(wt)

                $itemhtml.addClass("item_with_widget");

            } else { //item.widget == null

                switch (item.type) {//TODO: use constants
                    case 11:
                        $itemhtml = $("<input type='checkbox'>");
                        if (item.data == "1") {
                            $itemhtml.prop("checked", true);
			    $itemhtml.data("checked", 2);
                        } else if (item.data == "0") {
                            $itemhtml.prop("checked", false);
			    $itemhtml.data("checked", 0);
                        } else {
                            $itemhtml.prop("indeterminate", true);
			    $itemhtml.data("checked", 1);
                        }
                        break;
                    //                    case 3:
                    //                    case 4:
                    //                    case 3:
                    //                    case 6: 
                    //                    case 7:
                    case 1:
			if ( appxIsModifiable(item) && (item.special & 0x02) == 0x02) {
			    $itemhtml = $("<select data='" + item.data + "'>").val(item.data);
			} else {
			    if( item.size_rows > 1 )
				$itemhtml = $("<textarea>").css("padding", "0"); //remove extra width
			    else
				$itemhtml = $("<input type='text'>");
			    $itemhtml.val(item.data);
			    //                        $itemhtml.mask(maskstr);
			}
                        break;
                    //
		            case 3:
		            case 4:
		            case 6:
		            case 7:
		            case 9:
		            case 10:
		            case 15:
		                $itemhtml = $("<div>").addClass("appxdatefield");
		                //$itemhtml = $("<input type='text'>");
		                //$itemhtml.val(item.data);


		                var i = parseItemLongData(item.rawdata);
		                item.data = i.itemdata[0][0];
				var maskstr = i.itemdata[1][0].replace(/\_/g, "*"); //.replace(/X/g, "/");
				    
				for (var z = 0; z < i.itemdata[1][0].length; z++) {
				    if (i.itemdata[1][0][z] == "X") {
					maskstr = maskstr.replace(maskstr[z], i.itemdata[0][0][z]);
				    }
				}

		                /**************************************************
		                **
		                **  Build format and data for hidden picker item  
		                **
		                **************************************************/

		                var pickstr = "";
		                var datemsk = "";
		                var timemsk = "";
		                var part = "";

		                for (var z = 0; (z * 2) < i.itemdata[2][0].length; z++) {
		                    part = i.itemdata[2][0].substring(z * 2, (z * 2) + 2);

		                    if (part != "--") {
		                        switch (z) {

		                            case 0: // Century
		                                pickstr += part;
		                                datemsk += "yy";
		                                break;

		                            case 1: // Year
		                                pickstr += part;
		                                if (datemsk.length == 0) // If there is no century then we ass the mask for year only
		                                    datemsk += "y";
		                                break;

		                            case 2: // Month
		                                pickstr += part;
		                                datemsk += "mm";
		                                break;

		                            case 3: // Day
		                                pickstr += part;
		                                datemsk += "dd";
		                                break;

		                            case 4: // Hour
		                                if (datemsk.length > 0) // If there is a date part then we add a space separator to the string
		                                    pickstr += " ";
		                                pickstr += part;
		                                timemsk += "HH";
		                                break;

		                            case 5: // Minute
		                                if (timemsk.length > 0) { // If there are hours we add the colon separator
		                                    pickstr += ":";
		                                    timemsk += ":";
		                                }
		                                pickstr += part;
		                                timemsk += "mm";
		                                break;

		                            case 6: // Second
		                                if (timemsk.length > 0) { // If the are minutes we add the colon separator
		                                    pickstr += ":";
		                                    timemsk += ":";
		                                }
		                                pickstr += part;
		                                timemsk += "ss";
		                                break;

		                            case 7: // Thousands
		                                if (timemsk.length > 0) { // If there are seconds we add the period separator
		                                    pickstr += ".";
		                                    timemsk += ".";
		                                }
		                                pickstr += part + "0"; // Appx does thousands, not milliseconds so we add the third digit
		                                timemsk += "l";
		                                break;
		                        } // end switch

		                    }

		                } // end for loop

		                var pickval = '{"value":"' + pickstr + '","datemsk":"' + datemsk + '","timemsk":"' + timemsk + '"}';
		                /**************************************************
		                **
		                **  
		                **
		                **************************************************/
		                //var maskstr = i.itemdata[0][0].replace(/[a-zA-Z0-9]/g, "0");//i.itemdata[1][0].replace(/\_/g, "0"); //.replace(/X/g, "/");

		                //$itemhtml.mask(maskstr);

		                //var df = $("<input type='text'>").val(i.itemdata[0]);
		                var dv = $("<input class='appxdatevalue' type='text' style='width: 100%; height: 100%'>").val(i.itemdata[0]);
		                var df = $("<input class='appxdatepicker' type='hidden'>").val(pickval);

		                //$(df).mask('00/00/00 00:00:00');
		                $(dv).mask(maskstr);

		                $itemhtml.append(dv);  //.mask('00/00/00')
		                $itemhtml.append(df);  //.mask('00/00/00')

		                //$itemhtml.data("original", i.itemdata[0]);

		                //                $itemhtml.click(function () {
		                //                    //alert("adding datepicker");
		                //                    $(this).css("z-index", "100000");
		                //                    $(this).datepicker("dialog", "10/12/2012");
		                //                });

		                //need mask from server
		                //$itemhtml.mask('0000/00/00'); //$itemhtml.val(item.data);

		                //need mask from server
		                //$itemhtml.mask('0000/00/00');

		                //jquery ui has lots of format options
		                //$itemhtml.datepicker("option", "dateFormat", "&apos;day&apos; d &apos;of&apos; MM &apos;in the year&apos; yy");

		                //$itemhtml.addClass("appxdatefield");
		                //$itemhtml.datepicker();

		                //$itemhtml.val(item.data);

		                //$itemhtml.click(function () {
		                //alert("adding datepicker");
		                //$(this).css("z-index", "100000");
		                //$(this).datepicker();

		                //});

		                //need mask from server
		                //$itemhtml.mask('0000/00/00');


		                break;
                    //case 15: 

                    default:

                        //20140328 chris@praclox.nl: non widget items not showing anymore
                        if (appxIsModifiable(item)) {//} && false) {
			    if (item.size_rows > 1) {
				$itemhtml = $("<textarea>").css("padding", "0"); //remove extra width
			    } else {
				$itemhtml = $('<input type="text">');
			    }
			    $itemhtml.val(item.data);
			    
                        } else {

                            $itemhtml = $("<div>");
                            //$itemhtml = $("<input type='text'>");
                            $itemhtml.html(item.data);
                        }
                } //end switch(item.type)

            } // END if(item.widget != null)

            // FLD_SPEC_MOD
            // can't we run this after the item's elem is created and set prop disable == true or false?
            if (appxIsModifiable(item)) {//item.type == 1 &&
                //item.data = item.data.replace(/\xB6/g, "\r\n").trim(); //all occurrences of ?
		
                // all modifiable items need input class
                // TODO:  also need to track changed(dirty) items and only send those back in sendappxshow()
                $itemhtml.addClass("input");

                
                $itemhtml.on("input change", { wx: item.widget }, function(e) {
                    $(this).addClass("dirty");
                    appxSetStatusStateText(APPX_STATE_DIRTY);

                    //check if last char is not a space or else it's not saved
                    if (e.data.wx && $(this).val().slice(-1) != ' ') {
                        appx_session.valueTimerStart(e.data.wx.wCommandValueAdjusted);
                    }
                });
                //$itemhtml.css({ "border-color": "#d7d7d7", "border-style": "outset" });
		
                $itemhtml.addClass("appx-modifiable");
		
		if (appxIsToken(item)) {
		    if (wt == WIDGET_TYPE_RAW_TEXT) {
			$itemhtml.attr('maxlength', item.size_cols);
		    }
		}
		else {
		    if (item.maxLen) $itemhtml.attr('maxlength', item.maxLen);
		}
                
            } else {   //ELSE !FLD_SPEC_MOD

                // TODO:  need to rethink how this work because items have different html elements base on whether
                // in CHANGE MODE or INQUIRE MODE, maybe check FLD_SPEC_MOD when checking widgetType???
                if (wt != WIDGET_TYPE_PASSWORD && wt != WIDGET_TYPE_PROGRESS_BAR && wt != WIDGET_TYPE_CHECK_BOX && wt != WIDGET_TYPE_HTML_VIEWER && wt != WIDGET_TYPE_PICTURE) {
		    //if (wt != WIDGET_TYPE_LISTBOX && wt != WIDGET_TYPE_PASSWORD && wt != WIDGET_TYPE_PROGRESS_BAR && wt != WIDGET_TYPE_CHECK_BOX && wt != WIDGET_TYPE_HTML_VIEWER) {
                    //if (wt == null || wt == WIDGET_TYPE_RAW_TEXT || wt == WIDGET_TYPE_TEXT_AREA) {
		    
		    //                    if (item.type == 6 || item.type == 7 || item.type == 8 || item.type == 9 || item.type == 10) {
		    //                        debugger;
		    //                    } else {
		    //if (item.data.trim() = "0") {
		    //    debugger;
		    //}    
		    
		    $itemhtml = $("<div>");
		    
		    if (item.pos_row <= appx_session.screenrows - 3) {
			if (item.size_rows > 1 || wt != WIDGET_TYPE_LABEL) {//dont mangle fonts by pre tag
			    var $pre = $("<div>").css({ "margin": "0", "padding": "0" });
			    if (item.size_rows > 1) $pre.css("white-space", "pre-wrap"); //20140325 chrisa: added wordwrap
			    else $pre.css("white-space", "pre-wrap");
			    $pre.html(item.data).appendTo($itemhtml);
			} else {
			    $itemhtml.html(item.data);
			}
		    }
		    //                    }

		    
		}

		if( appxIsModifiableCapable( item )) {
		    appxIsModifiableCapable(item);
		    $itemhtml.addClass("appx-not-modifiable");
		}
		
            } //END FLD_SPEC_MOD

            if (appxIsUppercase(item))//nullOk = 0/1(?), uppercase = 2
                $itemhtml.css("text-transform", "uppercase"); 
	    
	    if( appxIsModifiable(item))
		$itemhtml.prop("disabled", false);
	    else
		$itemhtml.prop("disabled", true);
	    
	    if (appxIsNullOk(item)) { //format field = 4
                $itemhtml.addClass("appx-nullok");
	    } else {
                var i = parseItemLongData(item.rawdata);
		if( i && i.itemdata[0][0] == "" )
		    $itemhtml.addClass("appx-nullok");
	    }
	    
	    if (appxIsMasked(item)) { //format field = 4
		$itemhtml.addClass("masked");
		
		var i = parseItemLongData(item.rawdata);
		
		var maskstr = i.itemdata[1][0].replace(/\_/g, "*"); //.replace(/X/g, "/");
		
		for (var z = 0; z < i.itemdata[1][0].length; z++) {
		    if (i.itemdata[1][0][z] == "X") {
			maskstr = maskstr.replace(maskstr[z], i.itemdata[0][0][z]);
		    }
		}
		
		$itemhtml.mask(maskstr);
		
		$itemhtml.val(i.itemdata[0]);
	    }

	    //scannable
	    //if ((item.options & 0x08) == 0x08) { //format field = 4
	    //var i = $("<img src='binoculars.png' />").css({ "width": appx_session.colwidthpx * 2, "height": appx_session.rowheightpx });
	    //$(i).css("top", $it
	    //$itemhtml.after(i);
	    
	    //$itemhtml.addClass("scannable");
	    
	    //}

	    if( wt == WIDGET_TYPE_LABEL )
		$itemhtml.addClass("label");
	    else
		$itemhtml.addClass("appxitem");

	    //$itemhtml.attr("id", "item_id_" + i.toString());//$itemhtml.attr("id", "item_id_" + i.toString());
	    $itemhtml.attr("id", "appxitem_" + item.pos_col + "_" + item.pos_row);//TODO: use data()
	    $itemhtml.on("focus", function () {//{ val:item.data }
            var ida = $(this).attr("id").split('_');
            logca("item focus: " + ida[1] + "." + ida[2]);
            appxPutCursor(ida[1], ida[2]);
	    });
	    
	    appxwidgetdimensions(item, $itemhtml);
	    appxwidgetshandlerprops(item, $itemhtml);
	    
	    // TODO:  Move this up to tests for widget types ~ line 60 - CS 03/12/2014
	    //get token field data
	    if (appxIsToken(item)) {
                    //itm.tokendata = item.tokendata;
                    //itm.token_cacheid = ab2str(itm.tokendata.slice(0, 8));
                    //itm.token_cache_sig = ab2str(itm.tokendata.slice(8, 16));
                    //itm.token_group = itm.tokendata.slice(16, 18);
                    //itm.token_app = ab2str(itm.tokendata.slice(18, 21));
                    //itm.token_ap_ver = ab2str(itm.tokendata.slice(21, 23));
                    //itm.token_filler = itm.tokendata.slice(23, 24);
		if (appxIsModifiable(item) || wt == WIDGET_TYPE_LISTBOX) {
		    appx_session.token_groups[item.token_group] = appx_session.server.replace(/\./g, "_") + "_" + appx_session.port + "_" + item.token_cacheid + "_" + item.token_app + "_" + item.token_ap_ver;
		    
		    var cacheid = appx_session.server.replace(/\./g, "_") + "_" + appx_session.port + "_" + item.token_cacheid + "_" + item.token_app + "_" + item.token_ap_ver;
		    if (!appx_session.token_cache[cacheid]) {
			appx_session.token_cache.length++;
			appx_session.token_cache.keys.push(cacheid);
			appx_session.token_cache[cacheid] = { "cacheid": cacheid, "data": "" };
			//if (i == 1) appx_session.image_rollover.push(cacheid);//chrisa rollover
			if (!localStorage.getItem(cacheid)) {
			    sendappxtoken(item.token_group);
			} else {
			    appx_session.token_cache[cacheid].data = item.token_data;
			}
			
		    }
		    $itemhtml.addClass(cacheid);
		}
	    }

                //$itemhtml.css({ "z-index": 50000 });//z-index in screen.appxshowitems
                if (item.size_rows > 1) 
		            $itemhtml.css({ "overflow": "auto" });
                else if (item.widget == null || item.widget.wWidgetType != WIDGET_TYPE_SLIDER)
		            $itemhtml.css({ "overflow": "hidden", "white-space": "pre-wrap" });

                //appx_session.items.push(itemhtml);
                appx_session.items.push([item, $itemhtml, (item.pos_row * 256) + item.pos_col]);

                if (appxIsStatus(item)) {
		            //debugger;
		            if (appxIsStatusDb(item))       appxSetStatusDbText(item.data);
		            if (appxIsStatusAp(item))       appxSetStatusApText(item.data);
		            if (appxIsStatusVer(item))      appxSetStatusVerText(item.data);
		            if (appxIsStatusUser(item))     appxSetStatusUserText(item.data);
		            if (appxIsStatusDate(item))     appxSetStatusDateText(item.data);
		            if (appxIsStatusKeymap(item))   appxSetStatusKeymapText(item.data);
		            //if (appxIsStatusMsg(item))      appxSetStatusMsgText(item.data);
		            if (appxIsStatusMode(item))     appxSetStatusModeText(item.data);
		            if (appxIsStatusEmbld(item))    appxSetStatusEmbldText(item.data);
		            if (appxIsStatusProgress(item)) appxSetStatusProgressText(item.data);

			    if(appxIsStatusMode(item)) modeFound = true;
	            }

		        i++;

        } //end appxNullOk();

    }  catch (ex) { 
	    debugger;
	    console.log("appxitemshandler: " + ex);
	} //end try

    if( modeFound == false ) appxSetStatusModeText("");
} // end function appxitemhandler()

function appxIsMasked(item) {
    return ((item.options & FLD_OPT_MASK) != 0);
}

function appxIsModifiable(item) {
    return ((item.special & FLD_SPEC_MOD) == FLD_SPEC_MOD);
}

function appxIsModifiableCapable(item) {
    return ((item.special & FLD_SPEC_MOD_ABLE) == FLD_SPEC_MOD_ABLE);
}

function appxSetModifiableCapable(item, val) {
    if( val == true )
	item.special |= FLD_SPEC_MOD_ABLE;
    else
	item.special &= ~FLD_SPEC_MOD_ABLE;
}

function appxIsScannable(item) {
    return (appxIsModifiable(item) && ((item.options & FLD_OPT_SCAN) != 0));
}

function appxIsStatus(item)         { return ((item.options & FLD_OPT_STAT_BITS) != 0); }
function appxIsStatusDb(item)       { return ((item.options & FLD_OPT_STAT_BITS) == FLD_OPT_STAT_DB); }
function appxIsStatusAp(item)       { return ((item.options & FLD_OPT_STAT_BITS) == FLD_OPT_STAT_AP); }
function appxIsStatusVer(item)      { return ((item.options & FLD_OPT_STAT_BITS) == FLD_OPT_STAT_VER); }
function appxIsStatusUser(item)     { return ((item.options & FLD_OPT_STAT_BITS) == FLD_OPT_STAT_USER); }
function appxIsStatusDate(item)     { return ((item.options & FLD_OPT_STAT_BITS) == FLD_OPT_STAT_DATE); }
function appxIsStatusKeymap(item)   { return ((item.options & FLD_OPT_STAT_BITS) == FLD_OPT_STAT_KEYMAP); }
function appxIsStatusMsg(item)      { return ((item.options & FLD_OPT_STAT_BITS) == FLD_OPT_STAT_MSG); }
function appxIsStatusMode(item)     { return ((item.options & FLD_OPT_STAT_BITS) == FLD_OPT_STAT_MODE); }
function appxIsStatusEmbld(item)    { return ((item.options & FLD_OPT_STAT_BITS) == FLD_OPT_STAT_EMBLD); }
function appxIsStatusProgress(item) { return ((item.options & FLD_OPT_STAT_BITS) == FLD_OPT_STAT_PROGRESS); }

function appxIsToken(item) {
    return ((item.special & FLD_SPEC_TOKEN) == FLD_SPEC_TOKEN);
}

function appxIsUppercase(item) {
    return ((item.options & FLD_OPT_UCASE) != 0);
}

function appxIsNullOk(item) {
    return ((item.options & FLD_OPT_NULLOK) != 0);
}


function parseItemLongData(itemdata) {

    // Convert buffer to string
    var newarray = [];
    try {

        //newarray.push(123);
        newarray.push(91);
        newarray.push(34);
        for (var i = 0; i < itemdata.length; i++) {
            if (itemdata[i] == 0x02 || itemdata[i] == 0x01) {
                if (itemdata[i] == 0x02) {
                    newarray.push(34);
                    newarray.push(44);
                    newarray.push(34);
                }
                if (itemdata[i] == 0x01) {
                    newarray.push(34);
                    newarray.push(93);
                    newarray.push(44);
                    newarray.push(91);
                    newarray.push(34);
                }
            } else {
                newarray.push(itemdata[i]);
            }
        }
        newarray.push(34);
        newarray.push(93);
        //newarray.push(125);
        return JSON.parse('{"itemdata": [' + ab2str(newarray) + ']}');
    } catch (ex) { 
	    console.log("parseItemLongData: " + ex); 
	    console.log("parseItemLongData: data=" + newarray); 
	    newarray = [ 91, 34, 34, 93 ];
	    return JSON.parse('{"itemdata": [' + ab2str(newarray) + ']}');
    }
    
}

var FLD_OPT_NULLOK = 0x01;
var FLD_OPT_UCASE  = 0x02;
var FLD_OPT_MASK   = 0x04;
var FLD_OPT_SCAN   = 0x08;

var FLD_OPT_STAT_BITS     = 0xF0;
var FLD_OPT_STAT_DB       = 0x10;
var FLD_OPT_STAT_AP       = 0x20;
var FLD_OPT_STAT_VER      = 0x30;
var FLD_OPT_STAT_USER     = 0x40;
var FLD_OPT_STAT_DATE     = 0x50;
var FLD_OPT_STAT_KEYMAP   = 0x60;
var FLD_OPT_STAT_MSG      = 0x70;
var FLD_OPT_STAT_MODE     = 0x80;
var FLD_OPT_STAT_EMBLD    = 0x90;
var FLD_OPT_STAT_PROGRESS = 0xA0;

//MFld
//var FLD_SPEC_NONE       = 0x00;
//var FLD_SPEC_PICTURE    = 0x01;
var FLD_SPEC_TOKEN = 0x02;
//var FLD_SPEC_REQ_VAL    = 0x04;
var FLD_SPEC_MOD_ABLE = 0x08;
//var FLD_SPEC_ENCODING   = 0x30;
//var FLD_SPEC_DLU_TABOUT = 0x40;
var FLD_SPEC_MOD = 0x80;
