﻿/****************************************************************************/
//Resource Functions : appx-client-resource.js
//01/28/2014
//Chris Smith
/****************************************************************************/

//RESOURCE Message Handler
//Injects and Image into the DOM with an Object URL
//(allows server to send binary image data from the server without client saving locally
// or referencing a link to the server)
function appxresourcehandler(x) {
    var longCacheId = appx_session.pendingResources.shift();
    var cacheid = cleanClassName( appx_session.server + "_" + appx_session.port + "_" + ab2str(x.data.ap).trim() + "_" + ab2str(x.data.ver).trim() + "_" + longCacheId.trim() );

    try {
	if( x.data.len > 0 ) {
	    appx_session.image_cache[cacheid].blob = new Blob([toArrayBuffer(x.data.data)]);
	    if( x.data.loctype == 1 ) { // Client URL
		var a = ab2str(x.data.data);
	    }
	    else {
		var a = window.URL.createObjectURL(appx_session.image_cache[cacheid].blob);
	    }
	    if( longCacheId.length == 8 ) {
		try {
		    localStorage.setItem(cacheid, JSON.stringify(x.data.data));
		} catch(ex) {
		    console.log("can't save resource to localStorage: "+ex);
		}
	    }
	}
	else {
	    var a = "./images/missing.png";
	}
    }
    catch(ex) {
	console.log("image exception 1 = "+ex);
	var a = "./images/missing.png";
    }
    
    try {
	img = new Image();
	img.src = a;
	
	appx_session.image_cache[cacheid].url = a;

	img.onload = applyimage(cacheid);
    }
    catch(ex) {
    	console.log("appx-client-resource.js appxresourcehandler() failed to load image:" + ex);
    	applyimage(null);
    }
}

function sendappxresource(name) {
    var cacheArray = name.split(",");
    var subArray = cacheArray[0].split(".");
    console.log("write resource " + subArray[2]);
    appx_session.pendingResources.push(subArray[2]);
    console.log("ask for resource: "+name);
    var ms = {
        cmd: 'appxresource',
        args: name,
        handler: 'appxresourcehandler',
        data: null
    }; 

    appx_session.ws.send(JSON.stringify(ms));
}
