﻿/****************************************************************************/
//Session Functions : appx-client-session.js
//01/28/2014
//Chris Smith
/****************************************************************************/


//this function can be bound to a login's screen's button click event to handle logging into the appx server
function start_session() {
    appx_session.server = $("#appx_server").val();
    appx_session.port = $("#appx_port").val();

    sendappxlogin($("#appx_server").val(), $("#appx_port").val(), $("#appx_username").val(), $("#appx_password").val(), $("#appx_rows").val(), $("#appx_cols").val());
    //setTimeout("processhandlerloop", 5000);
    //processhandlerloop();
    //serverdataloop();
}

//this function can be bound to a login's screen's button click event to handle logging into the appx server
function reconnect_session() {
    sendappxreconnect($("#appx_server").val(), $("#appx_port").val(), $("#appx_username").val(), $("#appx_password").val(), $("#appx_reconnect").val());
    //setTimeout("processhandlerloop", 5000);
    //processhandlerloop();
    //serverdataloop();
}

//Sends login data to the server
function sendappxlogin(server, port, u, p, r, c) {

    appx_session.appx_server = server;
    appx_session.appx_port = port;
    appx_session.screenrows = parseInt(r) + 3;
    appx_session.screencols = parseInt(c);
    appx_session.setProp("host", server);
    appx_session.setProp("port", port);
    appx_session.setProp("screenRows", r);
    appx_session.setProp("screenColumns", c);


    //processque.push("appxlogin");

    var ms = {
        cmd: 'appxlogin',
        args: [server, port, u, p],
        handler: 'appxloginhandler',
        data: null
    };

    appx_session.ws.send(JSON.stringify(ms));
}

//Sends reconnect data to the server
function sendappxreconnect(server, port, u, p, pid) {

    //processque.push("appxlogin");

    var ms = {
        cmd: 'appxreconnect',
        args: [server, port, u, p, pid],
        handler: 'appxreconnecthandler',
        data: null
    };

    appx_session.ws.send(JSON.stringify(ms));
}

//Sends newsession data to the server,
// startup_info is a byte array of (app_id(3), database(3), process_type(10), process_name(30), filler(210) 
function sendappxnewsession(server, port, u, p, r, c, startup_info) {

    localStorage["newsession"] = JSON.stringify(startup_info);
    appx_session.connected = false;
    //window.open(window.location.href);
    window.open(window.location.href, "_blank", "toolbar=yes, scrollbars=yes, resizable=yes, location=yes, menubar=yes, status=yes, titlebar=yes");

}


//Sends login data to the server
function sendappxnewsessionlogin(server, port, u, p, si) {

    appx_session.appx_server = server;
    appx_session.appx_port = port;
    //appx_session.screenrows = parseInt(r) + 3;
    //appx_session.screencols = parseInt(c);
    appx_session.setProp("host", server);
    appx_session.setProp("port", port);
    //appx_session.setProp("screenRows", r);
    //appx_session.setProp("screenColumns", c);
                
    if (si.screenRows) {
        appx_session.screenrows = parseInt(si.screenRows) + 3;
        appx_session.setProp("screenRows", si.screenRows);
    }
    if (si.screenColumns) {
        appx_session.screencols = parseInt(si.screenColumns);
        appx_session.setProp("screenColumns", si.screenColumns);
    }

    var ms = {
        cmd: 'appxnewsession',
        args: [server, port, u, p, si.runApplication, si.runDatabase, si.runProcessType, si.runProcess, si.filler],
        handler: 'appxloginhandler',
        data: null
    };

    appx_session.ws.send(JSON.stringify(ms));

}


//Sends init data to the server
function sendappxinit() {

    //processque.push("appxinit");

    var ms = {
        cmd: 'appxmessage',
        args: [0, 0, 0, 2, 3, 0, 0, 0],
        handler: 'appxinithandler',
        data: null
    };

    appx_session.ws.send(JSON.stringify(ms));

    ms = {
        cmd: 'appxmessage',
        args: appxclientversion,
        handler: 'appxinithandler',
        data: null
    };

    appx_session.ws.send(JSON.stringify(ms));

}

//Sends feature data to the server
function sendappxfeatures() {
    //  alert("about to send next message");
    //processque.push("appxfeatures");

    //		FEATURE_RUNNING_GUI_CLIENT      = 0x00000001;
    //		FEATURE_PASS_PROC_ID_ON_INIT    = 0x00000002;
    //		FEATURE_LOAD_KEYMAP_FROM_SERVER = 0x00000004;
    //		FEATURE_RUN_VIA_RT_LOAD         = 0x00000008;
    //		FEATURE_DATA_PALETTE_SUPPORT    = 0x00000010;
    //		FEATURE_DOWNLOAD_FILE           = 0x00000020;
    //		FEATURE_UPLOAD_FILE             = 0x00000040;
    //		FEATURE_ADD_FIELD               = 0x00000080;
    //		FEATURE_GET_LANG_BLK            = 0x00000100;
    //		FEATURE_BUTTONS                 = 0x00000200;
    //		FEATURE_CLI_PRINT               = 0x00000400;
    //		FEATURE_REL41P1_SELECT          = 0x00000800;
    //		FEATURE_REL41P2_TOKENS          = 0x00001000;
    //		FEATURE_FILTER_BOXES            = 0x00002000;
    //		FEATURE_DATE_CHOOSER            = 0x00004000;
    //		FEATURE_AUTO_MENUS              = 0x00008000;
    //		FEATURE_BOX_ITM_WDGT            = 0x00010000;
    //		FEATURE_GUI_EDIT_CMD            = 0x00020000;
    //		FEATURE_LONG_DATA               = 0x00040000;
    //		FEATURE_TOKEN_SCANS             = 0x00080000;
    //		FEATURE_JOE2_GUI_CLIENT         = 0x00100000;
    //		FEATURE_NO_END_PARAG            = 0x00200000;
    //		FEATURE_CLIENT_CLIPBOARD        = 0x00400000;
    //		FEATURE_CONSTANTS_EXCH          = 0x00800000;
    //		FEATURE_SERVER_TOOLBARS         = 0x01000000;
    //		FEATURE_CLIENT_PATH_EXPANSION   = 0x02000000;
    //		FEATURE_ALPHA_CHANNEL_COLORS    = 0x04000000;
    //		FEATURE_LONG_TOKENS             = 0x08000000;
    //		FEATURE_SERVER_PULLDOWNS        = 0x10000000;
    //		FEATURE_LOGIN_FAILURE_MESSAGE   = 0x20000000;
    //		FEATURE_TABLE_WIDGETS           = 0x40000000;
    //		EXTENDED_FEATURES               = 0x80000000;  //table sort

    //moved to client.  client has control over feature mask settings
    //    var mask0 = 0x00;
    //    var mask1 = 0x05;
    //    //var mask1 = 0x05; //items and widgets
    //    var mask2 = 0x26;
    //    //var mask2 = 0xa6;  //turn on bit 0x00008000 for menus
    //    //var mask2 = 0xa6; //turn on menus
    //    var mask3 = 0xfb;

    //    appx_session.feature_mask = [parseInt(mask0), parseInt(mask1), parseInt(mask2), parseInt(mask3)];

    var ms = {
        cmd: 'appxmessage',
        //args: [0, 0, 36, 114], //minimun 0x00002472
        //args: [mask.toString(16)], //minimum
        //args: [parseInt(mask0), parseInt(mask1), parseInt(mask2), parseInt(mask3)], //minimum
        args: appx_session.feature_mask, //minimum
        handler: 'appxfeatureshandler',
        data: null
    };

    appx_session.ws.send(JSON.stringify(ms));

}

//Sends feature data to the server
function sendappxextendedfeatures() {

    var ms = {
        cmd: 'appxmessage',
        //args: [0, 0, 36, 114], //minimun 0x00002472
        //args: [mask.toString(16)], //minimum
        //args: [parseInt(mask0), parseInt(mask1), parseInt(mask2), parseInt(mask3)], //minimum
        args: appx_session.extended_feature_mask, //minimum
        handler: 'appxextendedfeatureshandler',
        data: null
    };

    appx_session.ws.send(JSON.stringify(ms));

}


//Sends constants data to the server
function sendappxconstants() {

    //processque.push("appxconstants");

    //        alert("about to send next message");

    //Preferred Screen size
    var ms = {
        cmd: 'appxmessage',
        args: [0, 0, 0, 0],
        handler: 'appxconstantshandler',
        data: null
    };

    appx_session.ws.send(JSON.stringify(ms));
}

// Sends attach data to the server
// Need to apply actual client window size
function sendappxattach() {

    //processque.push("appxattach");

    //        alert("about to send next message");
    //Preferred Screen size
    var ms = {
        cmd: 'appxmessage',
        args: [0, 0, 0, appx_session.screenrows, 0, 0, 0, appx_session.screencols],
        handler: 'appxattachhandler',
        data: null
    };

    appx_session.ws.send(JSON.stringify(ms));

    // Min Screen Size
    var ms = {
        cmd: 'appxmessage',
        args: [0, 0, 0, appx_session.screenrows, 0, 0, 0, appx_session.screencols],
        handler: 'appx_attach_handler',
        data: null
    };

    appx_session.ws.send(JSON.stringify(ms));
    // Max Screen Size
    var ms = {
        cmd: 'appxmessage',
        args: [0, 0, 0, appx_session.screenrows, 0, 0, 0, appx_session.screencols],
        handler: 'appxattachhandler',
        data: null
    };

    appx_session.ws.send(JSON.stringify(ms));

}

//Sends keymap data to the server
function sendappxkeymap() {

    //processque.push("appxkeymap");

    var ms = {
        cmd: 'appxmessage',
        args: [0, 0, 0, 1],
        handler: 'appxdataentryhandler',
        data: null
    };

    appx_session.ws.send(JSON.stringify(ms));

}

//PING Message Handler
function appxpinghandler() {
    sendappxping();
}

//Sends ping data to the server
function sendappxping() {

    //processque.push("appxping");

    var ms = {
        cmd: 'appxmessage',
        args: [0, 0],
        handler: 'appxpinghandler',
        data: null
    };

    appx_session.ws.send(JSON.stringify(ms));

}

//Client Handler Functions for Server Messages

//Login Message Handler
function appxloginhandler(rtndata) {
    var loginresponse = rtndata;
    if (loginresponse.transresult == "SUCCESS") {
        loggedin = true;
        //appxserverversion = rtndata.slice(0, 2);
        //rtndata = rtndata.slice(2, rtndata.length);
        $("#appx_login_modul").hide();
        //$("#appx-softkeys-container").show();
        $("#softkeys_showhide").show();
        $("#defaulttools_showhide").show();
        //$("#status_bar #appx-status-msg").html("Logged In Sucessfully..."); // + appxserverversion.toString());
        $("#appx-status-msg").prepend("Logged In Sucessfully...\n\n"); // + appxserverversion.toString());
    } else {
        loggedin = false;
        alert("Login Failed");
        window.location.reload();
        //appx_session.ws = null;
        //appx_session = new APPX("localhost", appxConnectorPort, null, 28, 110, basefontsize);

    }
}

function appxfinishhandler(rtndata) {
    if (localStorage["appx_prev_pids"]) {
        var prev_pids = JSON.parse(localStorage["appx_prev_pids"]);
        if (prev_pids.indexOf(appx_session.pid) >= 0) {
            prev_pids.splice(prev_pids.indexOf(appx_session.pid),1);
        }
        localStorage["appx_prev_pids"] = JSON.stringify(prev_pids);
    }
    appx_session.connected = false;
    if( appxCloseOnExit == "true" )
	close();
    else
	location.reload(true); //k.i.s.
    /*loggedin = false;
    appx_session.ws.close();
    appx_session = new APPX();
    $("#appx_main_container").html("&nbsp;");
    $("#appx_login_modul").show();
    $("#status_bar #appx_status").html("Logged Out Sucessfully...");;*/
}

//Reconnect Message Handler
function appxreconnecthandler(rtndata) {
    var reconnectresponse = rtndata;
    if (reconnectresponse) {
        var ms = {
            cmd: 'appxmessage',
            args: [0,0,0,0],
            handler: 'appxresourcehandler',
            data: null
        };

        appx_session.ws.send(JSON.stringify(ms));

    } else {
        var recon = false;
    }

}

//Init Message Handler
function appxinithandler(rtndata) {
    sendappxinit();
}

//Features Message Handler
function appxfeatureshandler() {
    sendappxfeatures();
}

//Features Message Handler
function appxextendedfeatureshandler() {
    sendappxextendedfeatures();
}

//Constants Message Handler
function appxconstantshandler() {
    sendappxconstants();
}

//Attach Message Handler
function appxattachhandler() {
    appx_session.connected = true;
    sendappxattach();
}

//KeyMap Message Handler
function appxkeymaphandler() {
    sendappxkeymap();
}

//PID Message Handler
function appxpidhandler(x) {
    appx_session.pid = ab2str(x.data);
    //$("#status_bar").append("<span id='appx_session_pid'> PID: " + appx_session.pid + "</span>");
    $("title").html("APPX HTML5 Client: " + appx_session.pid);
    //$.cookie("appxpid", null);
    //save previous session pids
    //if (!localStorage["appx_prev_pids"]) {
        var prev_pids = []; //JSON.parse(localStorage["prev_pids"]);
        prev_pids.push(appx_session.pid);
        localStorage["appx_prev_pids"] = JSON.stringify(prev_pids);
	//} else {
        //var prev_pids = JSON.parse(localStorage["appx_prev_pids"]);
        //if (prev_pids.indexOf(appx_session.pid) < 0) {
        //    prev_pids.push(appx_session.pid);
        //}
        //localStorage["appx_prev_pids"] = JSON.stringify(prev_pids);
	//}

    //sendappx????();
}
