/****************************************************************************/
//Widget Functions : appx-client-widget.js
//01/28/2014
//Chris Smith
/****************************************************************************/

//Need to Remove the default styles and set CUSTOM.css - !!!

//prevent default browser behavior on drops (e.g. navigating to contents)
function eventCatcher(e) {
    e = e || e.originalEvent || window.event;
    if (e.preventDefault) e.preventDefault();
    if (e.stopPropagation) e.stopPropagation();
    return false;
}
window.ondragover = function(e) { return eventCatcher(e); };
window.ondrop = function(e) { return eventCatcher(e); };


// this function is bound to a widget button's click event at the time the widget is created
//function appxwidgetcallback(id, boxdata) {//var option = null;//if (id) option = id.substring(11);
//CharView.accessServer
function appxwidgetcallback(option) {
    //if (!appxIsLocked())?
    //appx_session.lastOption = option;
    logca("appxwidgetcallback: " + option);
    var data = [];
    $("#appx_main_container").focus();
    $(".appxitem.dirty").each(function () { 
	    data.push(this); 
	});
    sendappxshow(option, data);
}


function appxwidgetdimensions(wori, $tag, box) {//Widget or Item
try {
    var x = 0, y = 0, w = 0, h = 0;
    var wx = wori, wt = WIDGET_TYPE_NONE;//0
    var colW = appx_session.colwidthpx;
    var rowH = appx_session.rowheightpx;

    if (box) {//translate items to box coordinates too
        x = box.begin_column - 1;
        y = box.begin_row;
        if (!appxIsScrollReg(box)) y--;
        //TODO: scanrecords not showing yet
        //if (!appxIsScrollAct(box) && !appxIsScrollReg(box)) y--;
    }

    //TODO/FIXME: Check this logic.  Tried to find a way to set negative 
    //-w and -h with the value from the size_cols and size_rows sent from 
    //the connector. Before this lines with negative values wouldn't always
    //work, as all widgets depended on purely widget @SSZ data for size. 
    //Lines don't always include the @SSZ data parameter we need for the 
    //neg width and height see WIDGET_TYPE_LINE
    var css = null;
    if (!wx.hasOwnProperty("wWidgetId")) {//Item
        if (wori.hasOwnProperty("widget") && wori.widget != null) {
            wx = wori.widget;
            wt = parseInt(wx.wWidgetType);
            if (wt != WIDGET_TYPE_PROGRESS_BAR && wt != WIDGET_TYPE_SLIDER) {
                //debugger;
                wx.wSizeW = wori.size_col || wori.size_cols;//sometimes 0
                wx.wSizeH = wori.size_row || wori.size_rows;
            }
        } else {
            x = (wx.pos_col - x) * colW;
            y = (wx.pos_row - y) * rowH;
            //debugger;
            w = (wx.size_cols || wori.size_col || wori.size_cols) * colW;
            h = (wx.size_rows || wori.size_row || wori.size_rows) * rowH;

	    if ( wori.type == 1 && appxIsModifiable(wori) && (wori.special & 0x02) == 0x02) {
		w += 25;
	    }
	    
        }
    }

    //widget positioning is relative to the parent box (appxshowhandler)
    var css = null;
    if (wx.hasOwnProperty("wWidgetId")) {//instanceof Widget
        wt = parseInt(wx.wWidgetType);
        var offX = 0, offY = 0, offW = 0, offH = 0;
        //CA: adc table widget ignored micro pos, we decided to fix it there
        if (true)//wt != WIDGET_TYPE_TABLE)
        {
            // The java client truncates, not rounds, the double NOT (~~) is
            // a fast and negative value safe way to truncation a float to an int.
            if (wx.wOffsetX) offX = ~~((wx.wOffsetX * colW) / 100);
            if (wx.wOffsetY) offY = ~~((wx.wOffsetY * rowH) / 100);
            if (wx.wOffsetW) offW = ~~((wx.wOffsetW * colW) / 100);
            if (wx.wOffsetH) offH = ~~ ((wx.wOffsetH * rowH) / 100);
        }
        x = (wx.wPositionX ? ((wx.wPositionX - x) * colW) + offX : 0);
        y = (wx.wPositionY ? ((wx.wPositionY - y) * rowH) + offY : 0);
        //if (wx.wWidgetType == WIDGET_TYPE_ROWTEXT) y -= 2;
        w = (wx.wSizeW ? (wx.wSizeW * colW) + offW : 0);
        h = (wx.wSizeH ? (wx.wSizeH * rowH) + offH : 0);
    }

    if ($tag) {
        $tag.css({ "position": "absolute", "left": x, "top": y });
        if (wt != WIDGET_TYPE_CHECK_BOX) {
            if (wt != WIDGET_TYPE_SLIDER) $tag.css("height", h);
            // The java client adds an extra 5 pixel to the widget of input fields
            // to make room for the decorations
            if (wt != WIDGET_TYPE_BOX && wt != WIDGET_TYPE_BUTTON) w += 5;
            if (wt == WIDGET_TYPE_LISTBOX) w += colW * 2.5;
            $tag.css("width", w);
        }
    }

    //if(w == 0 || h == 0) debugger;

} catch (ex) { alert("appxwidgetdimensions: " + ex); }
    return { "x": x, "y": y, "w": w, "h": h, "cw": colW, "rh": rowH };
}


//Widgets Message Handler
//Display.addField(MFld)
function appxwidgetshandler(x) {

    var wdgts = x.data;
    var i = 1;
    while (wdgts.length > 0) {

        var wdata = wdgts.shift();
        //debugger;
        var wx = new Widget(wdata[0], "", wdata[1], wdata[2], wdata[3]);//appxwidgetshandlerparams(wdata[1]));
        var wt = parseInt(wx.wWidgetType);

	//console.log("widget row=%d, col=%d label=%s, box=%d %s",wx.wPositionY,wx.wPositionX,wx.wLabel,wdata[0],ab2str(wdata[1]));
		
	if( wt == WIDGET_TYPE_ROWTEXT ) {
		var rowtxt = new RowTextStruct();
		rowtxt.type      = ROWTEXT_TYPE_WIDGET;
		rowtxt.boxid     = wdata[0];
		rowtxt.pos_row   = wx.wPositionY;
		rowtxt.pos_col   = wx.wPositionX;
		rowtxt.size_rows = wx.wSizeH;
		rowtxt.size_cols = wx.wSizeW;
		rowtxt.string    = wx.wLabel;
		appx_session.rowtext.push(rowtxt);
		continue;
	}

        var $tag = null;
        var layer = 10;

        switch (wt) {

            case WIDGET_TYPE_BUTTON://1
                $tag = $("<button>").css({ "margin": "0", "padding": "0" });//, "z-index": wx.boxid * 1000 + 1
                $tag.addClass("button");
                if (wx.wCommand) {
                    $tag.attr("id", "widget_sac_" + wx.wCommand);
                    $tag.click(function () {
                        appxwidgetcallback(this.id.substring(11));//this.id, wx.widgetparams);
                    });
                }
                if (!wx.wBorder) wx.wBorder = BORDER_BEVEL_RAISED;
                break;

            case WIDGET_TYPE_LABEL://2
		layer = 20;
                $tag = $("<div>");
                $tag.addClass("label");
                $tag.attr("id", "widget_sac_" + i.toString());
                break;

            case WIDGET_TYPE_PICTURE://3
		layer = 20;
                $tag = $("<div>");
                $tag.addClass("picture");
                wx.wIconEnabled = wx.wIconDisabled;//temporary
                break;

            case WIDGET_TYPE_BOX://4
		layer = 30;
                $tag = $("<fieldset>").css({ "margin": "0", "padding": "5px", "text-align": "left" });
                break;

            case WIDGET_TYPE_LINE://5;
		layer = 20;
                //<svg height="210" width="500">
                //  <line x1="0" y1="0" x2="200" y2="200" style="stroke:rgb(255,0,0);stroke-width:2" />
                //</svg>
                //debugger;
                $tag = $("<div>");//<svg><line x1=0 y1=10 x2=70 y2=10 style='stroke: rgb(0,0,0); stroke-width:2'></svg>");
                break;
            case WIDGET_TYPE_SLIDER: //31;
                // we've already set these in the itemshander
                //$tag = $("<div>");
                //$tag.slider();
                //$tag.height(13);  //need to handle this, temporary
                $tag.css({ "height": $tag.height() + 50, "width": $tag.width() + 15 });

                break;

            //           case WIDGET_TYPE_RADIO_DIAL: //32;

            case WIDGET_TYPE_PROGRESS_BAR: //33;
               // $tag = $("<div>");
                //$tag.progressbar();
                break;
            case WIDGET_TYPE_PASSWORD: //50
                //$tag = $("<input type='password'>").css({ "color": wx.wColorFg });
                //$tag.attr("id", "widget_sac_" + i.toString());
                break;


//            case WIDGET_TYPE_HTML_VIEWER: //60
//                //give unique id
//                if (wx.wHtmlViewerType == "autoedit") {
//                    $tag = $("<div>"); //.attr("id", "ck_" + parseInt(Math.random()).toString());
//                    //add class to call in applystyles()
//                    $tag.addClass("ckeditor");
//                }
//                            break;

//            case WIDGET_TYPE_HTML_EDITOR: //63
//                //give unique id
//                $tag = $("<div>").attr("id", "ck_" + parseInt(Math.random()).toString());
//                //add class to call in applystyles()
//                $tag.addClass("ckeditor");
//                break;
//
            case WIDGET_TYPE_FLASH_PLAYER://64;
                //can also use <embed></embed> see http://www.w3schools.com/html/html_object.asp
                $tag = $("<object data='http://www.w3schools.com/html/bookmark.swf'></object>");  
                break;

            case WIDGET_TYPE_MEDIA_PLAYER://65;
                
                if(wx.type == "video") {
                    $tag = $('<video><source src="http://www.w3schools.com/tags/movie.mp4" type="video/mp4">Your browser does not support the video tag.</video>');
                }
                if(wx.type == "audio") {
                    $tag = $('<audio controls><source src="http://www.w3schools.com/tags/horse.mp3" type="audio/mpeg">Your browser does not support the audio element.</audio>');
                }

                break;
            case WIDGET_TYPE_DATE_CHOOSER: // = 80
                $tag = $("<input type='text'>");
                $tag.val(item.data);
                $tag.addClass("appxdatefield");
//                $itemhtml.click(function () {
//                    //alert("adding datepicker");
//                    $(this).css("z-index", "100000");
//                    $(this).datepicker("dialog", "10/12/2012");
//                });

                //need mask from server
                $tag.mask('0000/00/00');
                break;

            case WIDGET_TYPE_TABLE: //90;
		wx.wSizeH -= 1;
                $tag = $("<div>")
                .addClass("appxtablewidget")
                .attr("id", "appxitem_" + wx.wPositionX + "_" + wx.wPositionY)
                .data("action", { "command": wx.wCommand, "command2": wx.wCommand2 })
                .data("row", wx.wPositionY)
                .data("col", wx.wPositionX);
                break;

            case WIDGET_TYPE_ROWTEXT://91
		layer = 0;
		if( wx.wPositionY > 1 ) {
		    wx.wLabel = "<pre>" + wx.wLabel + "</pre>";
		    wx.wColorFg = "black";
		    wx.wFont = "COURIER";
		    $tag = $("<div>");//.css("font-size", appx_session.basefontsize + "px");
		    $tag.addClass("rowtext");

		    if( wx.wLabel.length > 1 && wx.wLabel[0] == '=' )// && wx.wLabel[1] == '=' )
		    	$tag.addClass("ColHdgSep");
		    $tag.attr("id", "widget_sac_" + i.toString());
		}
                break;
        }

        if ($tag != null) {
            var dim = appxwidgetdimensions(wx, $tag);
            appxwidgetshandlerprops(wx, $tag);
            $tag.addClass("appxwidget");
            if (wt == WIDGET_TYPE_BOX) {
		if( wx.wLabel && wx.wLabel.length > 0 ) {
		    $tag.css({ "width": dim.w - (2 * dim.cw) - 2, "height": dim.h - dim.rh + 5, "left": dim.x + 2 });
		}
		else {
		    $tag.css({ "width": dim.w - (2 * dim.cw) + 2, "height": dim.h - dim.rh + 5 + 2 });
		}
                //TODO: overrules html set in appxwidgethandlerprops
                //color is black in ie(11) without inherit
                if (wx.wLabel) $tag.html("<legend style='color:inherit'><span>" + wx.wLabel + "</span></legend>");
            }

	    if (wt != WIDGET_TYPE_BOX) {
		$tag.css("z-index", (1000 * wx.boxid) + ( -1 * wx.wLayer ));
	    }

            appx_session.widgets.push([wx, $tag]);//new BoxWidget(wx.boxid, $tag)
        }

        i++;
    } //end while widgets
}

function appxwidgetshandlerprops(wori, $tag) { appxwidgetshandlerprops(wori, $tag, false); }
function appxwidgetshandlerprops(wori, $tag, bTitlebar) {

    var wx = wori;
    if (wori.hasOwnProperty("widget")) {//Item
        if (wori.widget != null) wx = wori.widget;//wx.wLabel = item.data;
        else return;
    }
    if (wx == null || $tag == null) return;

    var wt = parseInt(wx.wWidgetType);
    var bInput = ($tag.is("input") || $tag.is("select") || $tag.is("textarea"));
    if (!bTitlebar) {
        switch (wt) {
            //TODO? maybe merge with box, item and widgetshandler and return html tag

           //           case WIDGET_TYPE_NONE: //0;
           //           case WIDGET_TYPE_LABEL: //2;
           //           case WIDGET_TYPE_PICTURE: //3;
           //           case WIDGET_TYPE_BOX: //4;
           case WIDGET_TYPE_LINE: //5;
                //<svg height="210" width="500">
                //  <line x1="0" y1="0" x2="200" y2="200" style="stroke:rgb(255,0,0);stroke-width:2" />
                //</svg>
                //$tag = $("<svg><line x1=0 y1=0 x2=200 y2=200 style='stroke: rgb(255,0,0); stroke-width:2'></svg>");
                               
                $tag.css({"background":"transparent"});
                //$tag.width($tag.width() + 30);
               
                var $svg = $("<svg>").width("100%").height("100%");
               
                var $line = $("<line x1=10 y1=10 x2=200 y2=10 style='stroke: rgb(0,0,0); stroke-width:2'>");

                //TODO: FIXME: Looks like we need to take in negative width and height at appxwidgetdimensions()
                if($tag.width() == 0) {
                    if(wx.wSizeW && wx.wSizeW != 0) {
                        $tag.width((Math.abs(wx.wSizeW)) * appx_session.colwidthpx);
                    } else {
                        $tag.width((Math.abs(wx.size_col)) * appx_session.colwidthpx);
                        wx.wSizeW = wx.size_col * appx_session.colwidthpx;
                    }
                }
                if($tag.height() == 0) {
                    //debugger;
                    if(wx.wSizeH && wx.wSizeH != 0) {
                        $tag.height((Math.abs(wx.wSizeH)) * appx_session.rowheightpx);
                    } else {
                        $tag.height((Math.abs(wx.size_row)) * appx_session.rowheightpx);
                        wx.wSizeH = wx.size_row * appx_session.rowheightpx;
                    }
                }

                if(wx.wSizeW < 0) {
                    //a negative width means that x1 will be the right side of the tag 
                    //and x2 will be the left
//                    $line.attr({"x1": parseInt($line.attr("x1")) + $tag.width()});
//                    $line.attr({"x2": parseInt($line.attr("x1")) - $tag.width()}); 
                    $line.attr({"x1": $tag.width() - 10});
                    $line.attr({"x2": 10}); 

                } else {
                    $line.attr({"x2": parseInt($line.attr("x1")) + $tag.width()});
                }

                if(wx.wSizeH < 0) {
                    //$line.attr({"y2": parseInt($line.attr("y1")) - $tag.height() - appx_session.rowheightpx});
                    $line.attr({"y2": $tag.height() - 10});
                    $line.attr({"y1": 10});
                } else {
                    $line.attr({"y2": parseInt($line.attr("y1")) + $tag.height() - appx_session.rowheightpx});
                }

                if(wx.wColorFgDisabled) {
                    $line.css({"stroke":  wx.wColorFgDisabled});
                }

                if(wx.wSetLineWeight) { 
                    $line.css({"stroke-width":  appx_session.rowheightpx * (wx.wSetLineWeight/100)});
                } else {
                    $line.css({"stroke-width":  appx_session.rowheightpx * (32/100)});
                }

                if(wx.wLineUnitBase) {        
                    if(wx.wSetLineWeight) { 
                        $line.css({"stroke-width":  wx.wLineUnitBase * (wx.wSetLineWeight/100)});
                    } else {
                        $line.css({"stroke-width":  wx.wLineUnitBase * (32/100)});
                    }
                }

//                if(wx.wEndcapType) {
//                    $line.css({"stroke-linecap":  wx.wEndcapType == 2 ? "square" : wx.wEndcapType == 1 ? "butt" : "round"}); //stroke-dasharray
//                } else {
//                    $line.css({"stroke-linecap":  "round"}); //stroke-dasharray
//                }

                switch(wx.wEndcapType) {
                    case 2:
                        $line.css({"stroke-linecap":  "square"});
                        break;
                    case 1:
                        $line.css({"stroke-linecap":  "butt"});
                        break;
                    case 0:
                        $line.css({"stroke-linecap":  "none"});
                        break;
                    default:
                        $line.css({"stroke-linecap":  "round"});
                        break;
                }

                if(wx.wStrokePattern) {

                    var adjPattern = wx.wStrokePattern.split(",");
                    var p2 = [];
                    $.each(adjPattern, function(a, b) {
                        p2.push(parseInt(b) * (.64 * appx_session.colwidthpx));
                    });

                    $line.css({"stroke-dasharray":  p2.toString()});
                } else {
                    //$line.prop({"stroke-dasharray":  wx.wStrokePattern});
                }

                if(wx.wStrokePatternOffset) {
                    $line.css({"stroke-dashoffset": wx.wStrokePatternOffset * (.64 * appx_session.colwidthpx)});
                }

                $tag.css({"width": $tag.width() + 30, "height": $tag.height()});// + 30, "left": $tag.left() -10, "top": $tag.top() -10 });
                $tag.offset({"top": $tag.offset().top - 12, "left": $tag.offset().left - 12 });
                $svg.html($line[0].outerHTML);
                $tag.append($svg[0].outerHTML);

//               if($tag.find("line")) {               
//                $tag.find("line").attr({"x2": parseInt($tag.find("line").attr("x1")) + $tag.width()});
//                if(wx.wColorFgDisabled) $tag.find("line").css({"stroke":  wx.wColorFgDisabled});
//                if(wx.wSetLineWeight) $tag.find("line").css({"stroke-width":  appx_session.rowheightpx * (wx.wSetLineWeight/100)});
//                if(wx.wEndcapType) {
//                    $tag.find("line").css({"stroke-linecap":  wx.wEndcapType}); //stroke-dasharray
//                } else {
//                    $tag.find("line").css({"stroke-linecap":  "butt"}); //stroke-dasharray
//                }
//                if(wx.wStrokePattern) {
//                    $tag.find("line").css({"stroke-dasharray":  wx.wStrokePattern});
//                } else {
//                    //$tag.find("line").prop({"stroke-dasharray":  wx.wStrokePattern});
//                }
//               }

               break;
           //           case WIDGET_TYPE_RAW_TEXT: //20
           //           case WIDGET_TYPE_SPINNER: //30;
           case WIDGET_TYPE_SLIDER: //31;
               //$tag.height(13);
               $tag.css({ "height": $tag.height() + 50, "width": $tag.width() + 15 });
               break;
           //           case WIDGET_TYPE_RADIO_DIAL: //32;
            case WIDGET_TYPE_PROGRESS_BAR: //33;
//                $tag = $("<div>").html("").height(10).progressbar({
//                    value: parseInt(wori.data)
//                });
                break;
                      //           case WIDGET_TYPE_SCROLL_BAR: //34;
           //           case WIDGET_TYPE_RADIO_BUTTON: //41;
           //           case WIDGET_TYPE_TOGGLE_BUTTON: //43;

            case WIDGET_TYPE_LISTBOX: //42;

                var opt = wx.wCommand;

                $tag.change(function () {

                                                    if (opt) {
                                                        appxwidgetcallback(opt);
                                                    }
                    //alert(opt + ":" + this.id + ":" + $(this).val());

                });
                break;
           case WIDGET_TYPE_CHECK_BOX: //40;

               break;
           //$(wx).html("<select>");
           //break;
           case WIDGET_TYPE_PASSWORD: //50
               //$tag = $("<input>");
               $tag.prop("type", "password");
               break;

           case WIDGET_TYPE_FILE_CHOOSER: //51
                //debugger;
                        $tag.on('click', function(e) {
                            //console.log('dragenter');
                            if (localos_session && localos_session.ws.readyState == 1) {
                                //eventCatcher(e);
                                var randclass = "awaiting_filepath"; // + parseInt(Math.random() * 10000);
                                $(this).addClass(randclass);
                                var ms = {
                                    cmd: 'file-dialog-nw',
                                    args: [],
                                    handler: '',
                                    data: {
                                        dbg: false,//show devtools, don't close window
                                        wgtid: randclass,
                                        wPosX: wx.wPositionX + 1,
                                        wPosY: wx.wPositionY + 1
                                    }
                                };
                                localos_session.ws.send(JSON.stringify(ms));
                                return false;
                            }
                        });
                break;
           //           case WIDGET_TYPE_COLOR_CHOOSER: //52
           //           case WIDGET_TYPE_TEXT_AREA: //59;
           //           case WIDGET_TYPE_HTML_VIEWER: //60;
           //           case WIDGET_TYPE_RTF_VIEWER: //61;
           //           case WIDGET_TYPE_CODE_VIEWER: //62;
           //           case WIDGET_TYPE_HTML_EDITOR: //63;
           //           case WIDGET_TYPE_FLASH_PLAYER: //64;
           //           case WIDGET_TYPE_MEDIA_PLAYER: //65;
           //           case WIDGET_TYPE_WEB_BROWSER: //66;
           //           case WIDGET_TYPE_BUTTON_GROUP: //70;
           //           case WIDGET_TYPE_DATE_CHOOSER: //80
           case WIDGET_TYPE_TABLE: //90;
	       if( wx.widgetExtraData.widget_extra_reuse == true ) {
		   var zzz = appx_session.gridcache[wx.tableHashKey]; 
	       } else {
		   var zzz = parseTableData(wx.widgetExtraData.widget_extra_data);
		   appx_session.gridcache[wx.tableHashKey] = zzz;
	       }
	       appx_session.currenttabledata["appxitem_" + wx.wPositionX + "_" + wx.wPositionY] = zzz;
	       $tag.data("tableHashKey",wx.tableHashKey);
               //$tag.jqgrid();
               //alert("table 313");
               break;
            //case WIDGET_TYPE_ROWTEXT: //91;
            //case WIDGET_TYPE_IMG_EDITOR_FRAME: //200;
            //case WIDGET_TYPE_ILF_EDITOR_FRAME: //201;
            //case WIDGET_TYPE_PRT_ON_SCR_FRAME: //202;
            //case WIDGET_TYPE_DATE_CHOOSER://80
        }
    }

    //<border>
    //if (!wx.wBorder && wx.isBox) wx.wBorder = BORDER_BEVEL_RAISED;
    if (wx.wBorder) {
        $tag.addClass("appx-border");
        switch (wx.wBorder) {
            case BORDER_NONE:
                $tag.addClass("appx-border-none");
                break;
            case BORDER_BEVEL_RAISED:
                $tag.addClass("appx-border-bevel-raised");//width = 2;
                break;
            case BORDER_SOFT_BEVEL_RAISED:
                $tag.addClass("appx-border-soft-bevel-raised");//width = 2;
                break;
            case BORDER_BEVEL_SUNKEN:
                $tag.addClass("appx-border-bevel-sunken");//width = 2;
                break;
            case BORDER_SOFT_BEVEL_SUNKEN:
                $tag.addClass("appx-border-soft-bevel-sunken");//width = 2;
                break;
            case BORDER_ETCHED_SUNKEN:
                $tag.addClass("appx-border-etched-sunken");
                break;
            case BORDER_ETCHED_RAISED:
                $tag.addClass("appx-border-etched-raised");
                break;
            case BORDER_IMAGE_EDITOR:
                $tag.addClass("appx-border-image-editor");
                break;
            case BORDER_SIMPLE_LINE:
                $tag.addClass("appx-border-simple-line");
                break;
            case BORDER_SIMPLE_LINE_WIDER:
                $tag.addClass("appx-border-simple-line-wider");//width = 2;
                break;
        }
        // because of styling on input[type=text], !important flags are needed on border classes and this inline style
        //if (wx.wColorFgDisabled) $tag.css("border-color", wx.wColorFgDisabled + " !important");
        if (wx.wColorFgDisabled) {
            $tag.attr('style', $tag.attr('style') + ';' + 'border-color:' + wx.wColorFgDisabled + ' !important');
        }

        if (bInput) {
            ////var bb = "border-box";//inside border IE8+
            ////$tag.css({ "box-sizing": bb, "-moz-box-sizing": bb, "-webkit-box-sizing": bb });
            //var width = $tag.css("border-width");
            //console.log(width);
            //$tag.height($tag.height() - (2 * width));
        }
    }
    //</border>

    //<color>
    if (wx.wColorBgWallpaper && !bTitlebar) {
        $tag.css("background-color", wx.wColorBgWallpaper);
        if (wx.wColorBgWallpaperNL) $tag.css("opacity", wx.wColorBgWallpaperNL);
    } else {
        if ((!bTitlebar || wx.wColorBg != null) && wx.wContentAreaFilled != null && !wx.wContentAreaFilled)
            wx.wColorBg = "transparent";
        if (wx.wColorBg) $tag.css("background-color", wx.wColorBg);
        if (wx.wColorBgNL) $tag.css("opacity", wx.wColorBgNL);
    }

    if (wx.wColorFg) {
        $tag.css("color", wx.wColorFg);
        if (wx.wColorFgNL) $tag.css("opacity", wx.wColorFgNL);
    }

    if( ! bInput && wx.wColorBgDisabled )
        $tag.css("background-color", wx.wColorBgDisabled);

    //if (wx.wColorBgRollover)//:BELOW
    //if (wx.wColorFgRollover)//:BELOW
    //</color>

    if (appx_session.showoptnums && wx.wCommand && wx.wCommand < 256) {
        /*var helpoptid = "opthelp_" + wx.wCommand;
        //!!!wx.wLabel += "<div class='optionhelp' style='
        position: absolute; left: "+($tag.width() - (appx_session.colwidthpx * 3.5))+"px;
        top: 0px; width: "+ appx_session.colwidthpx * 3 +"px;
        text-align: right; font-size: "+ ((appx_session.colwidthpx) * 1.75 * .65) +"px;'>"
         + wx.wCommand + "</div>";*/
        $("<span>").addClass("appx-option").html(wx.wCommand).appendTo($tag);
    }

    //TODO? add events only to items in active box
    if (wx.wCommandGotFocus) {//FIXME
        $tag.focus(function() {//AppxField.focusGained
            appx_session.valueTimerStop();
            if (!appxIsLocked()) {
                logca("wx.focus " + wx.wCommandGotFocus);
                appxwidgetcallback(wx.wCommandGotFocus);//this.id, wx.widgetparams);
            } else { logca("wx.focus: locked"); }
        });
    }

    if (wx.wCommandLostFocus) {//FIXME
        $tag.blur(function() {//AppxField.focusLost
            appx_session.valueTimerStop();//CA: key pause
            if (!appxIsLocked()) {
                logca("wx.blur");
                appxPutTabOut();
                //CA: Pete - value adjusted not needed on tab out
                //if ($(this).hasClass("dirty"))//wCommandValueAdjusted;
                //without timeout tab can switch back to the current field and 
                //make it hard to end the function
                setTimeout(function(cmd) {
                    logca("CommandLostFocus to: " + cmd);
                    if (!appxIsLocked()) appxwidgetcallback(cmd);
                    else logca("(locked)");
                }, 100, wx.wCommandLostFocus);
            } else { logca("wx.blur: locked"); }
        });
    }
    
    //if (wx.CommandValueAdjusted)//see appx-client-item input change

    //bind Enter keydown to default button
    if (wx.wDefaultButton && wt == WIDGET_TYPE_BUTTON)
        $tag.addClass("default");//TODO? should this be an id instead? (unique)

    //<dnd>
    if (wx.wDragAndDrop) {
        //click has screenX/Y, drag events don't, nw has position: mouse
        //don't need dragover/leave/drop, processed by nw popup
        $tag.on('dragenter', function(e) {
            //console.log('dragenter');
            if (localos_session && localos_session.ws.readyState == 1) {
                eventCatcher(e);
                var ms = {
                    cmd: 'dnd',
                    args: [],
                    handler: '',
                    data: {
                        dbg: false,//show devtools, don't close window
                        wDnD: wx.wDragAndDrop,
                        wPrnt: WIDGET_PRNT_TYPE_WIDGET,//TODO: could be ITEM
                        wPosX: wx.wPositionX + 1,
                        wPosY: wx.wPositionY + 1,
                    }
                };
                localos_session.ws.send(JSON.stringify(ms));
                return false;
            }
        });
    }
    //</dnd>

    if (wx.wEnabled != null && wx.wEnabled == false)
        $tag.prop("disabled", true);

    //<font>
    if (!wx.wFont && wx.wWidgetType == WIDGET_TYPE_LABEL) wx.wFont = "helvetica";
    if (wx.wFont) {
        //Remove the default font and set CUSTOM.css
        var ff = null;
        switch (wx.wFont) {
            case "helvetica"://MWidget special processing
                ff = (bInput ? "monospace" : "sans-serif");
                break;
            case "COURIER":
            case "FIXEDSYS":
            case "TERMINAL":
	    case "Monospaced":
                ff = "monospace";
                break;
            case "MS SERIF":
            case "TIMES ROMAN":
                ff = "serif";
                break;
            //case "ARIAL":
            //case "MS SANS SERIF":
        }
        if (ff != null) {
            $tag.css("font-family", ff);
            /*var htm = $tag.html();
            if (!bInput && htm.indexOf("<pre") != -1)
                $tag.html('<font face="Arial">' + htm + '</font>');*/
        }
    }

    if (wt == WIDGET_TYPE_TABLE) {
	if (wx.wFontSize) {
	    $tag.css("line-height",(wx.wFontSize * 1.5)+"px");
	}
	else {
	    $tag.css("line-height",(appx_session.basefontsize*1.5)+"px");
	}
    }

    if (wx.wFontSize)
        $tag.css("font-size", wt == (WIDGET_TYPE_BUTTON || bTitlebar) ? (wx.wFontSize * 1) : wx.wFontSize);
    else if (wt == WIDGET_TYPE_BUTTON || bTitlebar)
        $tag.css("font-size", (appx_session.colwidthpx * 1.50));
    //else if (wt == WIDGET_TYPE_ROWTEXT)
        //$tag.css("font-size", appx_session.basefontsize + "px");
    else //CA20140328: made size smaller to fit full process names in design and also fit rowtext under buttons
        $tag.css("font-size", (appx_session.colwidthpx * 1.67));//1.75

    if (wx.wFontStyle) {
        switch (wx.wFontStyle) {
            case "bold":
                $tag.css("font-weight", "bold");
                break;
            case "italic":
                $tag.css("font-style", "italic");
                break;
            case "bolditalic":
                $tag.css({ "font-weight": "bold", "font-style": "italic" });
                break;
        }
    }
    //</font>

    if( wx.wWidgetType == WIDGET_TYPE_LABEL ) {
	if( wx.wSizeH < 2 ) 
	    $tag.css("white-space", "pre");

	if( $tag.css("font-size").length > 0 )
	    $tag.css("padding-top", (appx_session.rowheightpx - parseInt($tag.css("font-size"))) / 2 + "px");
	else
	    $tag.css("padding-top", (appx_session.rowheightpx - 12) / 2 + "px");
    }

    if (wx.wHtmlViewerType == "autoedit") {
        //$tag = $("<textarea>").attr("id", "ck_" + parseInt(Math.random()).toString());
        $tag.addClass("ckeditor");//add class to call in applystyles()
    }

    //<icons> further processing below
    var $img = null;
    if ((wx.wIconEnabled || wx.IconRollover || (wx.wIconWallpaper && wt == WIDGET_TYPE_PICTURE)) && (!wx.isBox || bTitlebar)) {
        $img = $("<img>");
        if (wx.wIconEnabled)  
	    $img.addClass(appxGetCacheIcon(wx.wIconEnabled) + "_img");
        else if (wx.wIconWallpaper)  
	    $img.addClass(appxGetCacheIcon(wx.wIconWallpaper) + "_img");
    }
    //if (wx.wIconRollover)//:BELOW
    if ((wx.wIconWallpaper && wt != WIDGET_TYPE_PICTURE) && !bTitlebar) {
        $tag.addClass(appxGetCacheIcon(wx.wIconWallpaper));
        if (!wx.wTilingMode) wx.wTilingMode = MODE_TILE;
        else if (wx.wTilingMode != MODE_TILE) $tag.css("background-repeat", "no-repeat no-repeat");
        switch (wx.wTilingMode) {
            case MODE_TILE:
                $tag.css("background-repeat", "repeat repeat");
                break;
            case MODE_EXPAND:
                $tag.css("background-size", "100% 100%");
                break;
            case MODE_CENTER:
                $tag.css("background-position", "center center");
                break;
            case MODE_N:
                $tag.css("background-position", "center top");
                break;
            case MODE_E:
                $tag.css("background-position", "right center");
                break;
            case MODE_S:
                $tag.css("background-position", "center bottom");
                break;
            case MODE_W:
                $tag.css("background-position", "left center");
                break;
            case MODE_NE:
                $tag.css("background-position", "right top");
                break;
            case MODE_NW:
                $tag.css("background-position", "left top");
                break;
            case MODE_SE:
                $tag.css("background-position", "right bottom");
                break;
            case MODE_SW:
                $tag.css("background-position", "left bottom");
                break;
        }
    }
    //</icons>

    if (wx.wJscript) {
        $tag.bind(wx.wJevent, function () {
            eval(wx.wJscript);
        });
    }
    /*if( wx.wJscript ) {
        $tag.focus(function () {
            eval(wx.wJscript);
        });
    }*/

    //if (wx.wLabel)//:BELOW

    //<margin> TODO: test if this works like it should
    var cel = appxGetCellSize();
    if (wx.wMarginB)
        $tag.css("padding-bottom", ((wx.wMarginB * cel.h) / 100));
    if (wx.wMarginL)
        $tag.css("padding-left", ((wx.wMarginL * cel.w) / 100));
    if (wx.wMarginR)
        $tag.css("padding-right", ((wx.wMarginR * cel.w) / 100));
    if (!wx.wMarginT && wt == WIDGET_TYPE_TEXT_AREA) wx.wMarginT = 10;
    if (wx.wMarginT)
        $tag.css("padding-top", ((wx.wMarginT * cel.h) / 100));
    //if (wx.wMarginT != null || wx.wMarginB != null || wx.wMarginL != null || wx.wMarginR != null)
    //$tag.css("background-color", "red");
    //</margin>

    //if (wx.wMovable)//draggable() works after appending to dom, see showscreen()

    if (wx.wSetDropShadow) {//debugger;//http://css3gen.com/box-shadow/
        //default values in parseAndSetShadow
        var factor   = .01 * ((appx_session.rowheightpx + appx_session.colwidthpx) / 2);
        var distance = wx.wSetDropShadowDistance * factor;//25
        var size     = Math.round(wx.wSetDropShadowSize * factor);//distance
        var angle    = wx.wSetDropShadowAngle * ((Math.PI) / 180);//45
        var opacity  = wx.wSetDropShadowOpacity;//50 (2dp)
        var color    = appxColorXlate(wx.wSetDropShadowColor, opacity);//#000
    
        var horx   = Math.round(distance * Math.cos(angle));
        var very   = Math.round(distance * Math.sin(angle));
        var blur   = size;
        var spread = size / 100;//approach 

        if (wx.wContentAreaFilled != null && !wx.wContentAreaFilled) {
            var shade  = horx + 'px ' + very + 'px ' + blur + 'px ' + color;
            $tag.css("text-shadow", shade);
        } else {
            var shade  = horx + 'px ' + very + 'px ' + blur + 'px '+ spread + 'px ' + color;
            $tag.css("box-shadow", shade);
        }
    }

    //alignment usually handled by container classes :BELOW
    //if (!wx.wSetHorizTextPos) wx.wSetHorizTextPos = "LEFT";
    if (wx.wSetHorizTextPos && bInput) {
        switch (wx.wSetHorizTextPos) {
            case "CENTER":
                $tag.css("text-align", "center");
                break;
            case "LEFT":
                $tag.css("text-align", "left");
                break;
            case "RIGHT":
                $tag.css("text-align", "right");
                break;
        }
    }

    //if (wx.wSetImageScale)//:BELOW

    //vertical-align doesn't work as one might expect
    //if (!wx.wSetVertTextPos) wx.wSetVertTextPos = "CENTER";
    /*if (wx.wSetVertTextPos) {
        switch (wx.wSetVertTextPos) {
            case "BOTTOM":
                $tag.css("vertical-align", "bottom");
                break;
            case "CENTER":
                $tag.css("vertical-align", "middle");
                break;
            case "TOP":
                $tag.css("vertical-align", "top");
                break;
        }
    }*/

    //if (wx.wShortcut)//:BELOW
    //if(wx.wShowClose)//:BELOW
    //if(wx.wShowHelp)//:BELOW
    //if(wx.wShowOk)//:BELOW
    //if (wx.wTilingMode)//:BELOW

    if (wx.wTooltip) {
        $tag.prop('title', wx.wTooltip); // <-- does not support HTML tags in tooltip
        $tag.tooltip({ content:function() {
            return $(this).prop('title');//this.title();
        }});
    }

    //TODO: maybe previous work is not needed when not visible?
    if (wx.wVisible != null && wx.wVisible == false)
        $tag.css("display", "none");

/*==============================================================================
:BELOW - Start building our label/icon container and rollover events
------------------------------------------------------------------------------*/

    //<boxLabelIcon>
    if (bInput || wt == WIDGET_TYPE_ROWTEXT) {
        if (wx.wLabel) {
            if (bInput) $tag.val(wx.wLabel);//input or textarea without child elements
            else $tag.html(wx.wLabel);//has <pre> tag, don't surround with container
        }
    } else {//if ($tag.find("pre").length == 0) {
        var $box = $("<div>").addClass("appx--box");//container
        $box.css({"width": "100%"});
        //$box.css("line-height", appx_session.rowheightpx + "px");
        var clsText = appxGetClassText(wx);
        $box.addClass(clsText).appendTo($tag);
        var $div = $("<div>");
        //keyboard shortcut combinations (Alt+char) wt == WIDGET_TYPE_BUTTON
        //TODO: should we recommend using Alt+Shift or Alt+Ctrl?
        if (wx.wLabel != null && wx.wLabel.substr(0, 6) == "<html>") wx.wLabel = wx.wLabel.substr(6);
        if (wx.wShortcut && $tag.is("button")) {
            var sc = wx.wShortcut.toUpperCase();//keyhandler sees uppercase
            if (sc != "D" && sc != "C") {//these don't work nicely (IE)
                $tag.addClass("appx-shortcut-" + sc.charCodeAt(0));
                if (wx.wLabel) {
                    //FIXME:  NEED A BETTER FIX FOR LABELS WITH HTML
                    // adding the <u> tag grabs the wrong instance of
                    // the letter sometimes and causes raw html in buttons
                    // --
                    // this code prevents the underline
                    // in the shortcut if wLabel is HTML
                    if(wx.wLabel.indexOf("<") == -1) {
                        var lbl = wx.wLabel;
                        var pos = lbl.indexOf(sc);
                        if (pos == -1) pos = lbl.indexOf(sc.toLowerCase());
                        if (pos != -1) {
                            wx.wLabel = (
                                lbl.substr(0, pos) + "<u>" +
                                lbl.substr(pos, 1) + "</u>" +
                                lbl.substr(pos + 1)
                            );
                        }
                    }
                }
            }
        }
        if (wx.wLabel) {
            //if (wx.wLabel.substr(0, 6) == "<html>") wx.wLabel = wx.wLabel.substr(6);
            $div.html(wx.wLabel);

	    if( bTitlebar )
		$div.width("100%");
        }

        if ($img == null) {
            if (wx.wLabel) $box.append($div);
        } else {
            $box.addClass(ICON);
            if (wx.wSetImageScale && wx.wTilingMode != MODE_EXPAND && wx.wTilingMode != MODE_TILE ) {//CharView.loadImage > scaleImage
                $img.load({ wis:wx.wSetImageScale }, function(e) {
                    var scalingHeight = 9;//14 seems to big? appx_session.basefontsize;
                    var scalingWidth  = e.data.wis;
                    if (scalingHeight > scalingWidth) scalingHeight = scalingWidth;
                    //var y = ~~(scalingHeight * scalingWidth / 100);
                    //var x = ~~(y / $(this).height() * $(this).width());
                    var y = 14 * wx.wSetImageScale / 100;
                    var x = y  * $(this).width / $(this).height()
			$(this).css({ "height": y, "width": x });
                });
            }
            var clsIcon = appxGetClassIcon(wx);
            $box.addClass(clsIcon);
            if (clsIcon == ICON_ABOVE_TEXT) {
                $box.append($img);
                $box.append($div);
            } else if (clsIcon.indexOf("leading")  != -1) {
                $box.addClass(ICON_LEADING);
                $box.append($img);
                $box.append($div);//div.appendTo($box);
            } else {
                if (clsIcon.indexOf("trailing") != -1)
                    $box.addClass(ICON_TRAILING);
                else if (clsIcon == ICON_BEHIND_TEXT)
                    $div.css("text-align", "center");
                $box.append($div);
                $box.append($img);
            }
        }
    }
    //</boxLabelIcon>

    //<rollover>
    if (
        wx.wColorBgRollover || wx.wColorBgRolloverNL ||
        wx.wColorFgRollover || wx.wColorFgRolloverNL ||
        wx.wIconRollover
    ) {//hover
        if (wx.wIconRollover) {
            $tag.addClass(appxGetCacheIcon(wx.wIconRollover) + "_imgRO");
            var iconRollover = function() {
                var src = $img.attr("src"), srcRO = $tag.attr("srcRO");
                //if (clsIcon == ICON_BEHIND_TEXT) src = $tag.css("background-image");
                if (src != undefined && srcRO != undefined) {
                    $tag.attr("srcRO", src);
                    $img.attr("src", srcRO);
                    /*if (clsIcon == ICON_BEHIND_TEXT) {
                        if (srcRO.indexOf("url") == -1) srcRO = "url('" + srcRO + "')";
                        $tag.css("background-image", srcRO);
                    }*/
                }
            };
        }
        $tag.mouseenter(function () {
            //TODO: test if we should pass the wx data as an argument
            if (wx.wColorBgRollover)
                $tag.css("background-color", wx.wColorBgRollover);
            if (wx.wColorBgRolloverNL)
                $tag.css("opacity", wx.wColorBgRolloverNL);
            if (wx.wColorFgRollover)
                $div.css("color", wx.wColorFgRollover);
            if (wx.wColorFgRolloverNL)
                $div.css("opacity", wx.wColorFgRolloverNL);
            if (wx.wIconRollover)
                iconRollover();
        }).mouseleave(function () {
            //container
            if (wx.wColorBgRollover)
                $tag.css("background-color", (wx.wColorBg ? wx.wColorBg : ""));
            if (wx.wColorBgRolloverNL)
                $tag.css("opacity", (wx.wColorBgNL ? wx.wColorBgNL : 1.0));
            //labeltext
            if (wx.wColorFgRollover)
                $div.css("color", (wx.wColorFg ? wx.wColorFg : ""));
            if (wx.wColorFgRolloverNL)
                $div.css("opacity", (wx.wColorFgNL ? wx.wColorFgNL : 1.0));
            if (wx.wIconRollover)
                iconRollover();
        });
    }
    //</rollover>

    //<titlebarButtons> had to move this down here
    if (bTitlebar) {
        var $boxTitle = $("<span>").addClass("appx-title-buttons").appendTo($tag);
        var titleBarButton = function(opt) {
            var $btnTitle = $("<button>").css({//addClass titlebutton
                "font-size": ~~((appx_session.colwidthpx) * 1.40) + "px",
                "height": (appx_session.rowheightpx - 4) + "px",
                "width": (appx_session.rowheightpx - 4) + "px"
            });
            switch (opt) {
                case OPT_END:
                    $btnTitle.addClass("appx-title-button-close").html("X");
                    break;
                case OPT_ENTER:
                    $btnTitle.addClass("appx-title-button-ok").html("&#10004;");
                    break;
                case OPT_WHATS_THIS:
                    $btnTitle.addClass("appx-title-button-help").html("?");
                    break;
            }
            $btnTitle.appendTo($boxTitle);
            $btnTitle.click(function () { appxwidgetcallback(opt); });
        };
        if (wx.wShowHelp == null || wx.wShowHelp == true) {
            titleBarButton(OPT_WHATS_THIS);
        }
        //TODO: add wShowOk & wShowClose to tab order if active box
        if (wx.wShowOk == null || wx.wShowOk == true) {
            titleBarButton(OPT_ENTER);
        }
        if (wx.wShowClose == null || wx.wShowClose == true) {
            titleBarButton(OPT_END);
        }
    }
    //</titlebarButtons>
}

//function BoxWidget(boxid, html) { this.boxid = boxid; this.html = html; }

function GridCacheProps() {
    self = this;
    self.scrollTop = null;
    self.scrollLeft = null;
    self.selrows = [];
}

//MWidget Object
Widget.prototype.self = null;
function Widget(boxid, html, widgetData, widgetExtraData, fullWidget) {

    //current object alias
    self = this;//http://javascript.about.com/od/objectorientedjavascript/a/oop12.htm

    self.boxid = boxid;
    self.html = html;
    //self.widgetparams = widgetparams;

    self.forceAntiAlias = -1;
    self.forceMultiLine = -1;
    self.forceMovable = -1;

    self.what_str = "@(#)Appx $Header: /src/cvs/appxHtml5/server/appx-client-widget.js,v 1.119 2014/12/19 14:19:02 pete Exp $";
    self.wWidgetId = null;
    self.wLayer = null;
    self.wLabel = null;
    self.wShortLabel = null;
    self.wTooltip = null;
    self.wGroupName = null;
    self.wShortcut = null;
    self.wMovableCommand = null;
    self.wCommand = null;
    self.wCommand2 = null;
    self.wCommandGotFocus = null;//OPT_NULL
    self.wCommandLostFocus = null;//OPT_NULL
    self.wCommandValueAdjusted = null;//OPT_NULL
    self.wLocalList = null;
    self.wEnabled = null;
    self.wUsageMenu = false;
    self.wUsageToolbar = false;
    self.wUsagePopup = false;
    self.wSepBefore = null;
    self.wSepAfter = null;
    self.wRolloverEnabled = null;
    self.wBorderPainted = null;
    self.wContentAreaFilled = null;
    self.wSelected = null;
    self.wFocusPainted = null;
    self.wVisible = null;
    self.wRequiresSelection = null;
    self.wInvert = null;
    self.wPaintTicks = null;
    self.wPaintTickLabels = null;
    self.wSnapToTicks = null;
    self.wShowHelp = null;
    self.wShowClose = null;
    self.wShowOk = null;
    self.wShowMax = null;
    self.wShowMin = null;
    self.wMovable = null;
    self.wResizable = null;
    self.wDockable = null;
    self.wDefaultButton = null;
    self.wTabable = null;
    self.wColorFg = null;
    self.wColorFgNL = null;
    self.wColorBg = null;
    self.wColorBgNL = null;
    self.wColorFgDisabled = null;
    self.wColorFgDisabledNL = null;
    self.wColorBgDisabled = null;
    self.wColorBgDisabledNL = null;
    self.wColorFgRollover = null;
    self.wColorFgRolloverNL = null;
    self.wColorBgRollover = null;
    self.wColorBgRolloverNL = null;
    self.wColorBgWallpaper = null;
    self.wColorBgWallpaperNL = null;
    //self.wColorBorder = null;
    //self.wColorBorderNL = null;
    self.wFileFilter = null;
    // <---

    // not implemented yet.

    self.wMinValue = null;
    self.wMaxValue = null;
    self.wTickMajor = null;
    self.wTickMinor = null;
    self.wTilingMode = null;
    self.wBorder = null;
    self.wWidgetType = null;
    self.wMarginT = null;
    self.wMarginB = null;
    self.wMarginL = null;
    self.wMarginR = null;
    self.wPositionX = null;
    self.wPositionY = null;
    self.wSizeW = null;
    self.wSizeH = null;
    self.wOffsetX = null;
    self.wOffsetY = null;
    self.wOffsetW = null;
    self.wOffsetH = null;
    self.wTabGroup = null;
    self.wFileChooserMode = null;
    self.wEndcapType = null;

    //    var  wPictureLocation = null;

    self.wBoxNumber = null;
    self.wTabSubGroupId = null;
    self.wIconEnabled = null;
    self.wIconDisabled = null;
    self.wIconPressed = null;
    self.wIconSelected = null;
    self.wIconRollover = null;
    self.wIconRolloverSelected = null;
    self.wIconWallpaper = null;
    self.wSetHorizTextPos = null;
    self.wSetVertTextPos = null;
    self.wSetHorizAlign = null;
    self.wSetVertAlign = null;
    self.wOrientation = null;
    self.wFont = null;
    //added these two instead of wFont = {name}-{style}-{size}
    self.wFontSize = null;
    self.wFontStyle = null;
    self.wSetFormSize = null;
    self.wSetProcessType = null;
    self.wSetFrameClass = null;
    self.wSetImageScale = null;
    self.wSetLineWeight = null;
    self.wSetStrokeWeight = null;
    self.wSetBorderArc = null;
    self.wSetAntiAlias = null;
    self.wSetDropShadow = null;
    self.wSetDropShadowSize = null;
    self.wSetDropShadowOpacity = null;
    self.wSetDropShadowColor = null;
    self.wSetDropShadowDistance = null;
    self.wSetDropShadowAngle = null;
    self.wSetScroller = null;
    self.wForceWidget = null;
    self.wStrokePattern = null;
    self.wStrokePatternOffset = null;
    self.wLineUnitBase = null;
    self.wHtmlViewerType = null; //chris@praclox.nl_20120418_R47_AppxHtmlControl
    self.wDragAndDrop = null; //chris@praclox.nl_20120427_R83_DragAndDrop
    self.wResFont = null;
    self.wResBundle = null;
    self.wEditorConfig = null;
    self.wPcbId = null;
    self.wFrameImageKey = null;
    self.wHashSig = null;
    self.wMenuNo = null;//MMenu()
    self.wMenuUse = null;//MMenu()

    self.delimiter = '\t';
    self.delimiterStr = "" + self.delimiter;
    self.widgetLen = 0;
    self.widgetData = widgetData;//null;
    self.widgetExtraData = widgetExtraData;
    self.widgetExtraLen = 0;
    self.wJscript = null;
    self.wJevent = null;
    self.bytesInCount = 0;
    self.tableHashKey = null;

    if(fullWidget) {
        //debugger;
        self.size_row = fullWidget.size_row;
        self.size_col = fullWidget.size_col;
    }

    self.parseData();//if (widgetparams || self.widgetparams) self.CreateFromJSON(widgetparams);
}

/* <position> icon & text */

function appxGetCacheIcon(wIcon) {
    var ai = wIcon.split('.'), cache = appx_session.image_cache;
    var cacheid = cleanClassName( appx_session.server + "_" + appx_session.port + "_" + ai[0].replace("#","") + "_" + ai[1] + "_" + ai[2] );
    if (!cache[cacheid]) {
        cache.length++;
        cache.keys.push(cacheid);
        cache[cacheid] = { "cacheid": cacheid, "url": "", "blob": null, "wIcon": wIcon };
        //if (i == 1) appx_session.image_rollover.push(cacheid);//chrisa rollover
        if (!localStorage.getItem(cacheid)) {
            sendappxresource(wIcon);
        } else {
            //var curresource = !localStorage.getItem(cacheid);
            cache[cacheid].blob = new Blob([toArrayBuffer(JSON.parse(localStorage.getItem(cacheid)))]);
            cache[cacheid].url = window.URL.createObjectURL(cache[cacheid].blob);
            cache[cacheid].wIcon = wIcon;
        }
    } else {
        if (cache[cacheid].wIcon != wIcon) {
            sendappxresource(wIcon);
            cache[cacheid].wIcon = wIcon;
        }
    }
    return cacheid;
}

//icon align [sub 0ad widget(extend)(button)]
//TH = WIDGET TEXT POS HORIZ
//TV = WIDGET TEXT POS VERT
//TM = WIDGET TILING MODE
var ICON                 = "appx-icon";
var ICON_LEADING         = "appx-icon-leading";//extra class for all leading forms
var ICON_TRAILING        = "appx-icon-trailing";//extra class for all trailing forms
var ICON_NULL            = "appx-icon-null";           // 0 TH = _   & TV = _   & TM = _
var ICON_BEHIND_TEXT     = "appx-icon-behind-text";    // 1 TH = C   & TV = _|C
var ICON_ABOVE_TEXT      = "appx-icon-above-text";     // 2 TH = C   & TV = B
var ICON_TRAILING_TEXT   = "appx-icon-trailing-text";  // 3 TH = L   & TV = _|C
var ICON_BELOW_TEXT      = "appx-icon-below-text";     // 4 TH = C   & TV = T
var ICON_LEADING_TEXT    = "appx-icon-leading-text";   // 5 TH = _|R & TV = _|C
var ICON_TRAILING_BOTTOM = "appx-icon-trailing-bottom";// 6 TH = L   & TV = B
var ICON_LEADING_BOTTOM  = "appx-icon-leading-bottom"; // 7 TH = _|R & TV = B
var ICON_TRAILING_TOP    = "appx-icon-trailing-top";   // 8 TH = L   & TV = T
var ICON_LEADING_TOP     = "appx-icon-leading-top";    // 9 TH = _|R & TV = T
var ICON_EXPAND_FILL     = "appx-icon-expand-fill";    //10 TH = _   & TV = _   & TM = EXPAND
var ICON_EXPAND_PROP     = "appx-icon-expand-prop";    //11 TH = _   & TV = _   & TM = TILE
appxGetClassIcon = function(wx) {
    var cls = ICON_LEADING_TEXT;//ICON_NULL
    if (
        (wx.wSetHorizTextPos == null || wx.wSetHorizTextPos == '') &&
        (wx.wSetVertTextPos  == null || wx.wSetVertTextPos  == '')
    ) {
        if (wx.wTilingMode) {
            switch (wx.wTilingMode) {
                case MODE_EXPAND:
                    cls = ICON_EXPAND_FILL;
                    break;
                case MODE_TILE:
                    cls = ICON_EXPAND_PROP;
                    break;
                default:
                    console.log("appxGetClassIcon: unhandled tiling " + wx.wTilingMode);
            }
        }
    } else {
        switch (wx.wSetHorizTextPos) {
            case 'LEFT':
                switch (wx.wSetVertTextPos) {
                    case 'BOTTOM':
                        cls = ICON_TRAILING_BOTTOM;
                        break;
                    case 'TOP':
                        cls = ICON_TRAILING_TOP;
                        break;
                    default://null,'','CENTER'
                        cls = ICON_TRAILING_TEXT;
                        break;
                }
                break;
            case 'CENTER':
                switch (wx.wSetVertTextPos) {
                    case 'BOTTOM':
                        cls = ICON_ABOVE_TEXT;
                        break;
                    case 'TOP':
                        cls = ICON_BELOW_TEXT;
                        break;
                    default://null,'','CENTER'
                        cls = ICON_BEHIND_TEXT;
                        break;
                }
                break;
            default://null,'','RIGHT'
                switch (wx.wSetVertTextPos) {
                    case 'BOTTOM':
                        cls = ICON_LEADING_BOTTOM;
                        break;
                    case 'TOP':
                        cls = ICON_LEADING_TOP;
                        break;
                    default://null,'','CENTER'
                        cls = ICON_LEADING_TEXT;
                        break;
                }
                break;
        }
    }
    return cls;
};

//widget text align
//AH = WIDGET ALIGN HORIZ
//AV = WIDGET ALIGN VERT
var TEXT_NULL        = "appx-text-null";       //0 AH = _   & AV = _
var TEXT_CENTER      = "appx-text-center";     //1 AH = _|C & AV = _|C
var TEXT_TOP         = "appx-text-top";        //2 AH = _|C & AV = T
var TEXT_RIGHT       = "appx-text-right";      //3 AH = R   & AV = _|C
var TEXT_BOTTOM      = "appx-text-bottom";     //4 AH = _|C & AV = B
var TEXT_LEFT        = "appx-text-left";       //5 AH = L   & AV = _|C
var TEXT_UPPER_RIGHT = "appx-text-upper-right";//6 AH = R   & AV = T
var TEXT_UPPER_LEFT  = "appx-text-upper-left"; //7 AH = L   & AV = T
var TEXT_LOWER_RIGHT = "appx-text-lower-right";//8 AH = R   & AV = B
var TEXT_LOWER_LEFT  = "appx-text-lower-left"; //9 AH = L   & AV = B
appxGetClassText = function(wx) {
    var cls = TEXT_LEFT;//TEXT_NULL

    if( wx.wWidgetType == WIDGET_TYPE_BUTTON )
	cls = TEXT_CENTER;

    if (wx.wSetHorizAlign || wx.wSetVertAlign) {
        switch (wx.wSetHorizAlign) {
            case 'LEFT':
                switch (wx.wSetVertAlign) {
                    case 'BOTTOM':
                        cls = TEXT_LOWER_LEFT;
                        break;
                    case 'TOP':
                        cls = TEXT_UPPER_LEFT;
                        break;
                    default://null,'','CENTER'
                        cls = TEXT_LEFT;
                        break;
                }
                break;
            case 'RIGHT':
                switch (wx.wSetVertAlign) {
                    case 'BOTTOM':
                        cls = TEXT_LOWER_RIGHT;
                        break;
                    case 'TOP':
                        cls = TEXT_UPPER_RIGHT;
                        break;
                    default://null,'','CENTER'
                        cls = TEXT_RIGHT;
                        break;
                }
                break;
            default://null,'','CENTER'
                switch (wx.wSetVertAlign) {
                    case 'BOTTOM':
                        cls = TEXT_BOTTOM;
                        break;
                    case 'TOP':
                        cls = TEXT_TOP;
                        break;
                    default://null,'','CENTER'
                        cls = TEXT_CENTER;
                        break;
                }
                break;
        }
    }
    return cls;
};
/* </position> */

//comm.msg.MWidget
//Set Drop Shadow - @SDS={visible},{distance},{size},{angle},{opacity},{color} 
//SDS: T,250,500,50,45,green
Widget.prototype.parseAndSetShadow = function(token)
{
    try
    {
        var tokens = token.split(",");
        if (tokens.length > 0 && tokens[0].toUpperCase() == "F")
            self.wSetDropShadow = false;
        else
            self.wSetDropShadow = true;

        if (tokens.length > 1 && tokens[1].length > 0)
            self.wSetDropShadowDistance = parseInt(tokens[1]);
        else
            self.wSetDropShadowDistance = 25;
            
        if (tokens.length > 2 && tokens[2].length > 0)
            self.wSetDropShadowSize = parseInt(tokens[2]);
        else
            self.wSetDropShadowSize = self.wSetDropShadowDistance;

        if (tokens.length > 3 && tokens[3].length > 0)
            self.wSetDropShadowAngle = parseInt(tokens[3]);
        else
            self.wSetDropShadowAngle = 45.0;
            
        if (tokens.length > 4 && tokens[4].length > 0)
            self.wSetDropShadowOpacity = parseInt(tokens[4]) * .01;
        else
            self.wSetDropShadowOpacity = 0.5;
            
        if (tokens.length > 5 && tokens[5].length > 0)
            self.wSetDropShadowColor = tokens[5];
        else
            self.wSetDropShadowColor = "#000000";
    }
    catch(e)
    {
        console.log("MWidget - bad setDropShadow " + e + "," + token);
    }
}

Widget.prototype.parseData = function () {//CreateFromJSON(widgetparams)
try {
    if (self.widgetData) {//|| widgetparams
	//self.widgetparams = appxwidgetshandlerparams(self.widgetparams);
        var st2 = null;
        var widgetparams = self.parseDataIntoPairs();
        for (var ct = 0; ct < widgetparams.length; ct++) {
            var key = widgetparams[ct].key;
            var val = widgetparams[ct].value.trim();
            switch (key) {
                case "SAC":
                    self.wCommand = parseInt(val);
                    break;
                case "SAC2":
                    self.wCommand2 = parseInt(val);
                    break;
                case "SGFC":
                    self.wCommandGotFocus = parseInt(val);
                    break;
                case "SLFC":
                    self.wCommandLostFocus = parseInt(val);
                    break;
                case "SB":
                    self.wBorder = parseInt(val);
                    break;
                //?case "SBF": break;
                case "SBN":
                    self.wBoxNumber = parseInt(val);
                    break;
                case "SBP":
                    if (val == 'F') self.wBorder = BORDER_NONE;
                    break;
                case "SCAF":
                    self.wContentAreaFilled = (val != 'F');
                    break;
                case "SCT":
                    self.wEndcapType = parseInt(val);
                    break;
                case "SDB":
                    self.wDefaultButton = (val != 'F');
                    break;
                case "SDBC":
                    if (val.length > 7) {
                        self.wColorBgDisabled = val.substr(0, 7);
                        self.wColorBgDisabledNL = parseInt(val.substr(7)) / 100;
                    } else {
                        self.wColorBgDisabled = val;
                    }
		    break;
                case "SDFC":
                    if (val.length > 7) {
                        self.wColorFgDisabled = val.substr(0, 7);
                        self.wColorFgDisabledNL = parseInt(val.substr(7)) / 100;
                    } else {
                        self.wColorFgDisabled = val;
                    }
                    break;
                case "SDI":
                    self.wIconDisabled = val;
                    break;
                case "SDND"://chris@praclox.nl_20120427_R83_DragAndDrop
                    self.wDragAndDrop = val;
                    break;
                case "SDS":
                    self.parseAndSetShadow(val);
                    break;
                case "SE":
                    self.wEnabled = (val != 'F');
                    break;
                case "SEBC":
                    if (val.length > 7) {
                        self.wColorBg = val.substr(0, 7);
                        self.wColorBgNL = parseInt(val.substr(7)) / 100;
                    } else {
                        self.wColorBg = val;
                    }
                    break;
                case "SEFC":
                    if (val.length > 7) {
                        self.wColorFg = val.substr(0, 7);
                        self.wColorFgNL = parseInt(val.substr(7)) / 100;
                    } else {
                        self.wColorFg = val;
                    }
                    break;
                case "SF":
                    st2 = val.split(",");
                    if (st2.length > 0) {
                        self.wFont = st2[0];
                    }
                    if (st2.length > 1) {
                        self.wFontStyle = st2[1].toLowerCase();
                        if (self.wFontStyle == "bold+italic" || self.wFontStyle == "bold + italic")
                            self.wFontStyle = "bolditalic";
                    }
                    if (st2.length > 2) {
                        self.wFontSize = parseInt(st2[2]);
                        // Sanity Check
                        if (self.wFontSize >= presetFontSizes.length)
                            self.wFontSize = 0;
                        // Convert to percentage from preset list
                        self.wFontSize = presetFontSizes[self.wFontSize];
                        // Convert percentage to real size
                        //* view.CharView.normalFont.getSize()) + Globals.getOptionValueInteger("widgetFontAdjust");
            //                            self.wFontSize = parseInt(self.wFontSize * .01 * 13 + 0);
                        self.wFontSize = (self.wFontSize * .01 * (appx_session.colwidthpx) * 1.70 ); // 1.67 ); //1.75 );
                        //self.wFontSize = parseInt(self.wFontSize * .01 * (appx_session.colwidthpx) * 1.76 ); // 1.67 ); //1.75 );

                    }
                    //fName = fName + "-" + fStyle;
                    //fName = fName + "-" + fSize;
                    break;
                case "SFCM":
                    self.wFileChooserMode = val;
                    break;
                case "SFIK":
                    self.wFrameImageKey = val;
                    break;
                case "SGN":
                    self.wGroupName = val;
                    break;
                case "SHA":
                    self.wSetHorizAlign = val;
                    break;
                case "SHCL":
                    self.wShowClose = (val != 'F');
                    break;
                case "SHHL":
                    self.wShowHelp = (val != 'F');
                    break;
                case "SHOK":
                    self.wShowOk = (val != 'F');
                    break;
                case "SHS":
                    self.wHashSig = parseInt(val);
                    break;
                case "SHTM":
                    self.wHtmlViewerType = val;
                    break;
                case "SHTP":
                    self.wSetHorizTextPos = val;
                    break;
                case "SI":
                    self.wIconEnabled = val;
                    break;
                case "SIS":
                    var iSize = parseInt(val);
                    if (iSize >= presetFontSizes.length) iSize = 0;
                    // Convert to percentage from preset list
                    if (iSize > 0)
                        self.wSetImageScale = parseInt(presetFontSizes[iSize]);
                    else
                        console.log("MWidget.parseData() Invalid Widget Image Scale = " + val + "for widget = " + self.widgetData.toString());
                    break;
                case "SJE":
                    self.wJevent = val;
                    break;
                case "SJS":
                    self.wJscript = val;
                    break;
                case "SL":
                    st2 = val.split(",");
                    self.wPositionY = parseInt(st2[1]); // * appx_session.rowheightpx) - appx_session.rowheightpx;
                    self.wPositionX = parseInt(st2[0]); // * appx_session.colwidthpx) - appx_session.colwidthpx;
                    break;
                case "SLN":
                    self.wLayer = parseInt(val);
                    break;
                case "SLUB":
                    self.wLineUnitBase = parseInt(val);
                    break;
                case "SLW":
                    self.wSetLineWeight = parseInt(val);
                    break;
                case "SM":
                    st2 = val.split(",");
                    if (st2.length > 0) self.wMarginT = parseInt(st2[0]);
                    if (st2.length > 1) self.wMarginL = parseInt(st2[1]);
                    if (st2.length > 2) self.wMarginB = parseInt(st2[2]);
                    if (st2.length > 3) self.wMarginR = parseInt(st2[3]);
                    break;
                case "SMATS":
                    self.wTickMajor = parseInt(val);
                    break;;
                case "SMAX":
                    self.wMaxValue = parseInt(val);
                    break;
                case "SMIN":
                    self.wMinValue = parseInt(val);
                    break;
                case "SMITS":
                    self.wTickMinor = parseInt(val);
                    break;
                case "SMN"://MMenu()
                    self.wShortcut = val;
                    break;
                case "SMT"://MMenu()
                    self.wMenuNo = parseInt(val);
                    break;
                case "SMV":
                    self.wMovable = true;
                    self.wMovableCommand = val;
                    //console.log("movable: " + ab4str(self.widgetData));
                    break;
                case "SOFF": //micro positioning (percentages)
                    st2 = val.split(",");
                    if (st2.length > 0) {
                        self.wOffsetY = parseInt(st2[0]);
                        if (self.wOffsetY > 127) {
                            self.wOffsetY = self.wOffsetY - 256;
                        }
                    }
                    if (st2.length > 1) {
                        self.wOffsetX = parseInt(st2[1]);
                        if (self.wOffsetX > 127) {
                            self.wOffsetX = self.wOffsetX - 256;
                        }
                    }
                    if (st2.length > 2) {
                        self.wOffsetW = parseInt(st2[2]);
                        if (self.wOffsetW > 127) {
                            self.wOffsetW = self.wOffsetW - 256;
                        }
                    }
                    if (st2.length > 3) {
                        self.wOffsetH = parseInt(st2[3]);
                        if (self.wOffsetH > 127) {
                            self.wOffsetH = self.wOffsetH - 256;
                        }
                    }
                    break;
                case "SPCB":
                    self.wPcbId = parseInt(val);
                    break;
                case "SPT":
                    self.wPaintTicks = (val != 'F');
                    break;
                case "SPTL":
                    self.wPaintTickLabels = (val != 'F');
                    break;
                case "SRBC":
                    //turn on alpha color bit
                    //check length of string
                    //if greater 6, last two is alpha
                    //use rgbs(0,0,0,0)
                    //20140328 chris@praclox.nl: aye
                    if (val.length > 7) {
                        self.wColorBgRollover = val.substr(0, 7);
                        self.wColorBgRolloverNL = parseInt(val.substr(7)) / 100;
                    } else {
                        self.wColorBgRollover = val;
                    }
                    break;
                case "SRE":
                    self.wRolloverEnabled = (val != 'F');
                    break;
                case "SRFC":
                    if (val.length > 7) {
                        self.wColorFgRollover = val.substr(0, 7);
                        self.wColorFgRolloverNL = parseInt(val.substr(7)) / 100;
                    } else {
                        self.wColorFgRollover = val;
                    }
                    break;
                case "SRI":
                    self.wIconRollover = val;
                    break;
                case "SSP":
                    //st2 = val.split(",");
                    self.wStrokePattern = val;//parseInt(st2[0]);
                    //self.wStrokePattern = parseInt(st2[1]);
                    break;
                case "SSPO":
                    //st2 = val.split(",");
                    self.wStrokePatternOffset = val;//parseInt(st2[0]);
                    //self.wStrokePattern = parseInt(st2[1]);
                    break;
                case "SST":
                    self.wShortLabel = val;
                    break;
                case "SSU":
                    var mask = parseInt(val);
                    if ((mask & WIDGET_SEP_BEFORE) == WIDGET_SEP_BEFORE)
                        self.wSepBefore = true;
                    if ((mask & WIDGET_SEP_AFTER) == WIDGET_SEP_AFTER)
                        self.wSepAfter = true;
                    break;
                case "SSZ":
                    st2 = val.split(",");
                    self.wSizeW = parseInt(st2[0]);// * appx_session.colwidthpx;
                    self.wSizeH = parseInt(st2[1]);// * appx_session.rowheightpx;
                    break;
                case "ST"://MMenu()
                    self.wLabel = val;
                    //if (val == "test") console.log(ab4str(self.widgetData));
                    break;
                case "STG"://MMenu()
                    self.wTabGroup = parseInt(val);
                    break;
                case "STM":
                    self.wTilingMode = parseInt(val);
                    break;
                case "STSG":
                    self.wTabSubGroupId = val;
                    break;
                case "STTT":
                    self.wTooltip = val;
                    break;
                case "SV":
                    self.wVisible = (val != 'F');
                    break;
                case "SVA":
                    self.wSetVertAlign = val;
                    break;
                case "SVAC":
                    //for listbox change event
                    //CA20141118:#3183 Key pause
                    //self.wCommand = val;
                    self.wCommandValueAdjusted = val;
                    break;
                case "SVTP":
                    self.wSetVertTextPos = val;
                    break;
                case "SWBC":
                    if (val.length > 7) {
                        self.wColorBgWallpaper = val.substr(0, 7);
                        self.wColorBgWallpaperNL = parseInt(val.substr(7)) / 100;
                    } else {
                        self.wColorBgWallpaper = val;
                    }
                    break;
                case "SWI":
                    self.wIconWallpaper = val;
                    break;
                case "SWID":
                    self.wWidgetId = val;
                    break;
                case "SWT":
                    self.wWidgetType = parseInt(val);
                    break;
                case "SWU":
                    var mask = parseInt(val);
                    if ((mask & WIDGET_USAGE_MENU) == WIDGET_USAGE_MENU)
                        self.wUsageMenu = true;
                    if ((mask & WIDGET_USAGE_TOOLBAR) == WIDGET_USAGE_TOOLBAR)
                        self.wUsageToolbar = true;
                    if ((mask & WIDGET_USAGE_POPUP) == WIDGET_USAGE_POPUP)
                        self.wUsagePopup = true;
                    break;
                case "USE"://MMenu()
                    self.wMenuUse = (val == 'T');
                    break;
                default:
                    console.log("WP: unhandled " + key + "=" + val);
                    break;
            }
        }
    }

    if( self.wWidgetType == WIDGET_TYPE_TABLE )
	self.tableHashKey = "pcb"+self.wPcbId+"fik"+self.wFrameImageKey+"sig"+self.wHashSig+"r"+self.wPositionY+"c"+self.wPositionX+"h"+self.wSizeH+"w"+self.wSizeW;

    if (self.wLayer == null) {
        self.wLayer = 10;
        if (self.wWidgetType != null) {
            switch (parseInt(self.wWidgetType)) {
                case WIDGET_TYPE_LABEL:
                case WIDGET_TYPE_PICTURE:
                case WIDGET_TYPE_LINE:
                    self.wLayer = 20;//button overlay issues, off for now
                    break;
                case WIDGET_TYPE_BOX:
                    self.wLayer = 30;//button overlay issues, off for now
                    break;
                case WIDGET_TYPE_ROWTEXT:
                    self.wLayer = 25;//put beneath buttons
                    break;
            }
            //if( wLayer != null && Globals.getOptionValueBoolean("oldLayerNumbers") == true )
                //wLayer = new Integer(wLayer.intValue() / 10);
        }
    }
} catch (ex) { alert("Widget.parseData: " + ex); }
};

Widget.prototype.parseDataIntoPairs = function() {
try {
    var widgetparams = {};
    var cnt = 0, pos;
    var widgetparam = "[";

    // We must preprcess the string so we don't accidentally split on an @ cahracter in the data, like in an email address
    debugger;
    var blockStart = -1;
    var blockEnd = -1;
    var offsetSave = -1;
    var parserStr = ab4str(self.widgetData);
    var mywidgetrawdata = [];
    for (var i = 0; i<parserStr.length; i++) {
	if (parserStr.charAt(i) == '@') {
	    offsetSave = i;
	}
	if (parserStr.charAt(i) == '=' && offsetSave >= 0) {
	    if (blockStart >= 0) {
		mywidgetrawdata.push(parserStr.substring(blockStart,offsetSave));
	    }
	    blockStart = offsetSave+1;
	    offsetSave = -1;
	}
    }

    if (blockStart >= 0 && blockStart < parserStr.length) {
	mywidgetrawdata.push(parserStr.substring(blockStart));
    }


    //var mywidgetrawdata = parserStr.split('\t');
    while (mywidgetrawdata.length > 0) {
        var kvpair = mywidgetrawdata.shift();
        if (kvpair.trim().length > 0 && kvpair != " ") {
            //20140331 chris@praclox.nl: value might contain an equals sign too
            //var kp = kvpair.split("=");
            var pos = kvpair.indexOf("=");
            if (pos > 0) {//kp.length > 1
                var kp0 = kvpair.substr(0, pos);
                var kp1 = kvpair.substr(pos + 1).replace(/\"/g, '');
                //widgetparam += '{"' + kp[0] + '": "' + kp[1].replace(/\"/g, '') + '", ' + '"key": ' + '"' + kp[0] + '", ' + '"value": ' + '"' + kp[1].replace(/\"/g, '') + '"}';
                if(kp0.trim().length > 0) { // && kp1.length > 0) {
                    if (cnt > 0) widgetparam += ", ";
                    widgetparam += '{ "key": "' + kp0 + '", "value": "' + kp1 + '"}';
                } else {
                    //debugger;
                }
                //if(kp1.indexOf("CJT") > -1) debugger;
            } else {
                logactivity("kvpair length not > 1: " + kvpair);
            }
            cnt++;
        }
    }
    widgetparam = widgetparam.replace(/\\/g, "\\\\");
    widgetparams = JSON.parse("" + widgetparam + "]");
} catch (ex) { console.log("WIDGET PARSE ERROR:\n\n" + widgetparam); }
    return widgetparams;
};

//function clickRowHandler(clicknum, cmd) {
//    //$(this).parent().append($("<input>").attr("id", $(this).closest(".appxtablewidget").prop("id") + "_tablerow_" + $(this).jqGrid('getCell', id, 'id')).val($(this).jqGrid('getCell', id, 'id')).addClass("tabledataitem"));
//    //if (cmd) {
//        if (clicknum == 1) {

//            sendappxshow(cmd, []);
//            return false;
//        } else {
//            if (appx_session.tablerowcleartimeout) {
//                clearTimeout(appx_session.tablerowcleartimeout);
//            }
//            sendappxshow(cmd, []);
//        }
//    //}

//    //$(wx).parent().append($("<input>").attr("id", $(wx).closest(".appxtablewidget").prop("id") + "_tablerow_" + $(wx).jqGrid('getCell', id, 'id')).val($(wx).jqGrid('getCell', id, 'id')).addClass("tabledataitem"));
//}

//function dblClickRowHandler(wx) {
//    //$(this).parent().append($("<input>").attr("id", $(this).closest(".appxtablewidget").prop("id") + "_tablerow_" + $(this).jqGrid('getCell', id, 'id')).val($(this).jqGrid('getCell', id, 'id')).addClass("tabledataitem"));
//    sendappxshow($wx.data("action").command2, []);
//    //$(wx).parent().append($("<input>").attr("id", $(wx).closest(".appxtablewidget").prop("id") + "_tablerow_" + $(wx).jqGrid('getCell', id, 'id')).val($(wx).jqGrid('getCell', id, 'id')).addClass("tabledataitem"));
//}

//we may need to make this generic and put in utils lib
function parseTableData(tabledata) {
    try {
    // Convert buffer to string
    var newstring = "";
    newstring += '["';
    //FIXME:  Probably a more efficient way to handle low order bits - CS - 04/02/2014
    for (var i = 0; i < tabledata.length; i++) {
	switch(tabledata[i].charCodeAt(0)) {
	case 0x01:
	    newstring += '"],["';
	    break;
	case 0x02:
	    newstring += '","';
	    break;
	case 0x03:
	    newstring += '||';
	    break;
	case 0x00: // null
	case 0x0A: // linefeed
	case 0x08: // backspace
	case 0x0C: // formfeed
	case 0x0D: // cr
	case 0x09: // tab
	    newstring += ' ';
	    break;
	case 0x5C: // backslash
	case 0x22: // double quote
	    newstring += '\\';
	    newstring += tabledata[i];
	    break;
	default:
	    newstring += tabledata[i];
	    break;
	}
    }
    newstring += '"]';
    return JSON.parse('{"tabledata": [' + newstring + ']}'); //ab2str(newarray) + ']}');
    } 
    catch(ex) {
	console.log("parseTableData() failed: "+ex);
	debugger;
	return "";
    }
}

//function sortTableGrid(cell, obj, sc) {
//    console.log(cell + '_' + parseInt(obj[appx_session.current_sort_index]));
//    return parseInt(obj[appx_session.current_sort_index]);

//}

function createGrid(cols, data, elem) {
    try {

        var id = $(elem).attr("id");
        var numrows = parseInt(data[0][0]);
        var numcols = parseInt(data[0][1]);
        var expand = data[0][2];
        var colsarry = data.slice(1, numcols + 1);
        var sortcols = [];
        var rowdata = data.slice(numcols + 1, data.length);

	// Build list of which columns have extra hidden sort columns
	sortcols.push(false); // id column
	sortcols.push(false); // selection column
        if (colsarry.length > 0) {
	    for (var i = 0; i < colsarry.length; i++) {
		if (colsarry[i][4].indexOf("Date") > -1 || colsarry[i][4].indexOf("Integer") > -1) {
		    sortcols.push(true);
		}
		else {
		    sortcols.push(false);
		}
	    }
        }

        var pnav = $('<div id="pager2"></div>').appendTo(elem);
        var table = $("<table id='newtablewidget_" + id + "'>");

        $(elem).append(table);
        $(elem).append(pnav);

	/////////////////////////////////////////////////////
	// Create the column models and names for the grid //
	/////////////////////////////////////////////////////

        var colnames = [];
        var colmodel = [];
        var sortcolmap = {};

	// Create hidden row id column
        colnames.push("id2");
        colmodel.push({
            "name": "id2",
            "index": "id2",
            "width": 1,
	    "hidden": true
        });

	// Create hidden selection column
        colnames.push("selected");
        colmodel.push({
            "name": "selected",
            "index": "selected",
            "width": 1,
            "hidden": true
        });

        for (var i = 0, j = 2; i < colsarry.length; i++, j++) {
	    var cleanName = colsarry[i][3].replace(/\'/g, "").replace(/\s/g, "_").toLowerCase();
	    var cellWidth = (parseInt(colsarry[i][2]) * appx_session.colwidthpx)  - 5;

	    if (sortcols[j] == false) {
		colnames.push(colsarry[i][3]);
		colmodel.push({
			"name": cleanName,
			"index": cleanName,
			"width": cellWidth,
			"sortable": true,
			"sorttype": function(cell) { 
			    return  $("<div>").html(cell).text();
			}
		    });
	    } else {
		colnames.push(colsarry[i][3]);
		colmodel.push({
			"name": cleanName,
			"index": cleanName,
			"width": cellWidth,
			"sortable": true,
			"sorttype": function(cell, obj) {
                            return obj[appx_session.current_sort_index];
                        }
                    });
		colnames.push("sortcol_" + j.toString());
		colmodel.push({
                        "name": "sortcol_" + j.toString(),
			"index": "sortcol_" + j.toString(),
			"width": 0,
			"hidden": true
		    });
		sortcolmap[cleanName] = "sortcol_" + j.toString();
	    }
	}

        appx_session.sortcolmap = sortcolmap;
        $("#newtablewidget_" + id).jqGrid({
            "autowidth": true,
            "caption": "",
            "colModel": colmodel,
            "colNames": colnames,
            "datatype": "local",
            "height": $(elem).height(),
            "hidegrid": false,
            "multiselect": true,
            "repeatitems": false,
	    "rowNum": 1000000,
            "shrinkToFit": false,
            "sortable": true,
            "onSortCol": function(index, iCol, sortorder) {
                appx_session.current_sort_index = appx_session.sortcolmap[index];
            },
            "onSelectRow": function(id) {
                if (!($(this).closest(".appxbox").hasClass("appx-not-modifiable") || appxIsLocked())) {
                    var cmd = $(this).closest(".appxtablewidget").data("action").command;
		    var selkeys = $(this).jqGrid('getGridParam', 'selarrrow');
		    var rows = [];

		    for (var i = 0; i < selkeys.length; i++) {
			rows.push($(this).jqGrid('getRowData', selkeys[i]).id2);
		    }

		    $(this).closest(".appxtablewidget").data("selkeys", rows);

                    appx_session.tablerowcleartimeout = setTimeout(function() {
			    if (cmd) {
				//TODO:  FIX ME: if dirty class needs checking , change to appxwidgetcallback(cmd)
				sendappxshow(cmd, []);
			    }
			}, 250);
                }
            },
            "ondblClickRow": function(rowid, iRow, iCol, e) {
		
                if (appx_session.tablerowcleartimeout) {
                    clearTimeout(appx_session.tablerowcleartimeout);
                }

                if (!($(this).closest(".appxbox").hasClass("appx-not-modifiable") || appxIsLocked())) {
		    var cmd = $(this).closest(".appxtablewidget").data("action").command2;
		    var selkeys = $(this).jqGrid('getGridParam', 'selarrrow');
		    var rows = [];
		    
		    for (var i = 0; i < selkeys.length; i++) {
			rows.push($(this).jqGrid('getRowData', selkeys[i]).id2);
		    }
		    
		    $(this).closest(".appxtablewidget").data("selkeys", rows);		    

		    if (cmd) {
			//TODO:  FIX ME: if dirty class needs checking , change to appxwidgetcallback(cmd)
			sendappxshow(cmd, []);
		    }
		}
            },
	    "beforeSelectRow": function(rowid, e) {
                if (!e.ctrlKey && !e.shiftKey) {
                    $(this).jqGrid('resetSelection');
                } else if (e.shiftKey) {
                    var initialRowSelect = $(this).jqGrid('getGridParam', 'selrow');
                    $(this).jqGrid('resetSelection');

                    var CurrentSelectIndex = $(this).jqGrid('getInd', rowid);
                    var InitialSelectIndex = $(this).jqGrid('getInd', initialRowSelect);
                    
		    if (CurrentSelectIndex > InitialSelectIndex) {
                        var startID = initialRowSelect;
                        var endID = rowid;
                    } else {
                        var startID = rowid;
                        var endID = initialRowSelect;
                    }

                    var shouldSelectRow = false;
                    var mytableid = $(this);
                    $.each($(this).jqGrid("getDataIDs"), function(_, id) {
                        if ((shouldSelectRow = id == startID || shouldSelectRow) && (id != rowid)) {
                            $(mytableid).jqGrid('setSelection', id, false);
                        }
                        return id != endID;
                    });
                }
                return true;
            }
        });

        // if the parent box is not active then block the UI for the grid
        if ($("#newtablewidget_" + id).closest(".appxbox").hasClass("appx-not-modifiable")) {
            $("#newtablewidget_" + id).closest(".ui-jqgrid").block({
                "message": null,
                "overlayCSS": {
                    "backgroundColor": '#000',
                    "opacity": 0.0,
                    "cursor": null
                }
            });
        }

        var mydata = rowdata;

        for (var i = 0; i < mydata.length; i++) {

            var newrow = [];
            for (var k = 0; k < mydata[i].length; k++) {
                var d = mydata[i][k].split("||");

                // We may get non-html tags and truncated tags.  Remove all tags for now.
                $junk = $("<div>").html(d[0]);
                if (d[0].length > 6 && d[0].substr(0, 6) == "<html>")
                    newrow.push($junk.html()); // if it contains an <html> prefix keep the tags
                else
                    newrow.push($junk.text()); // otherwise strip them so XML and other test does not confuse things

		if( sortcols[k] == true ) {
		    if (d.length > 1) {
			newrow.push(parseInt(d[1]));
		    }
		    else {
			newrow.push(0);
		    }
		}
            }

            var myrow = {};
            for (var j = 0; j < colnames.length; j++) {
                myrow[colnames[j].replace(/\'/g, "").replace(/\s/g, "_").toLowerCase()] = newrow[j];
            }

            $("#newtablewidget_" + id).jqGrid('addRowData', i + 1, myrow);

            if (mydata[i][1] == "true")
                $("#newtablewidget_" + id).jqGrid('setSelection', i + 1, true);
        }

        $("#newtablewidget_" + id).jqGrid('hideCol', 'cb');
    } catch (e) {
        console.log(e);
    }
}

presetFontSizes = [100, 25, 33, 50, 66, 75, 80, 85, 90, 95, 100, 105, 110, 115, 120, 125, 130, 140, 150, 175, 200, 300, 400, 500, 600, 700, 800, 900, 1000];

//Document
var BORDER_NONE              =  5;
var BORDER_SIMPLE_LINE       = 10;
var BORDER_SIMPLE_LINE_WIDER = 20;
var BORDER_ETCHED_SUNKEN     = 30;
var BORDER_ETCHED_RAISED     = 40;
var BORDER_BEVEL_SUNKEN      = 50;
var BORDER_BEVEL_RAISED      = 60;
var BORDER_SOFT_BEVEL_SUNKEN = 70;
var BORDER_SOFT_BEVEL_RAISED = 80;
var BORDER_IMAGE_EDITOR      = 90;
var BORDER_MAX               = BORDER_IMAGE_EDITOR;

//CharView
var MODE_TILE                = 1;
var MODE_EXPAND              = 2;
var MODE_CENTER              = 3;
var MODE_N                   = 4;
var MODE_E                   = 5;
var MODE_S                   = 6;
var MODE_W                   = 7;
var MODE_NE                  = 8;
var MODE_NW                  = 9;
var MODE_SE                  = 10;
var MODE_SW                  = 11;
/*var MODE_EXPAND_PROP         = 12;
var MODE_MENU_ITEM           = 13;
var MODE_TOOL_BUTTON         = 14;
var MODE_WINDOW_TITLE        = 15;*/

var TOKENIZE_WIDGET_TYPE_BUTTON = 1;
var TOKENIZE_WIDGET_TYPE_MENU = 2;
var TOKENIZE_WIDGET_TYPE_MENUHDR = 3;
var TOKENIZE_WIDGET_TYPE_BOX = 4;
var TOKENIZE_WIDGET_TYPE_ITM = 5;

var WIDGET_PRNT_TYPE_FRAME = 2;
var WIDGET_PRNT_TYPE_IMAGE = 3;
var WIDGET_PRNT_TYPE_ITEM = 5;
var WIDGET_PRNT_TYPE_WIDGET = 6;
var WIDGET_PRNT_TYPE_CHILD = 8;

var WIDGET_SEP_BEFORE = 1;
var WIDGET_SEP_AFTER = 2;

var WIDGET_TYPE_NONE = 0;
var WIDGET_TYPE_BUTTON = 1;
var WIDGET_TYPE_LABEL = 2;
var WIDGET_TYPE_PICTURE = 3;
var WIDGET_TYPE_BOX = 4;
var WIDGET_TYPE_LINE = 5;
var WIDGET_TYPE_RAW_TEXT = 20;
var X_WIDGET_TYPE_SPINNER = 30;
var WIDGET_TYPE_SLIDER = 31;
var X_WIDGET_TYPE_RADIO_DIAL = 32;
var WIDGET_TYPE_PROGRESS_BAR = 33;
var X_WIDGET_TYPE_SCROLL_BAR = 34;
var WIDGET_TYPE_CHECK_BOX = 40;
var X_WIDGET_TYPE_RADIO_BUTTON = 41;
var WIDGET_TYPE_LISTBOX = 42;
var X_WIDGET_TYPE_TOGGLE_BUTTON = 43;
var WIDGET_TYPE_PASSWORD = 50;
var WIDGET_TYPE_FILE_CHOOSER = 51;
var WIDGET_TYPE_COLOR_CHOOSER = 52;
var WIDGET_TYPE_TEXT_AREA = 59;
var WIDGET_TYPE_HTML_VIEWER = 60;
var X_WIDGET_TYPE_RTF_VIEWER = 61;
var X_WIDGET_TYPE_CODE_VIEWER = 62;
var WIDGET_TYPE_HTML_EDITOR = 63;
var WIDGET_TYPE_FLASH_PLAYER = 64;
var WIDGET_TYPE_MEDIA_PLAYER = 65;
var X_WIDGET_TYPE_WEB_BROWSER = 66;
var X_WIDGET_TYPE_BUTTON_GROUP = 70;
var WIDGET_TYPE_DATE_CHOOSER = 80;
var WIDGET_TYPE_TABLE = 90;
var WIDGET_TYPE_ROWTEXT = 91;
var WIDGET_TYPE_IMG_EDITOR_FRAME = 200;
var WIDGET_TYPE_ILF_EDITOR_FRAME = 201;
var WIDGET_TYPE_PRT_ON_SCR_FRAME = 202;

var WIDGET_USAGE_MENU = 1;
var WIDGET_USAGE_TOOLBAR = 2;
var WIDGET_USAGE_POPUP = 4;
